/// AUTO GENERATED BY build.rs

use std::collections::HashMap;

use webrender_build::shader::ShaderVersion;

pub struct SourceWithDigest {
    pub source: &'static str,
    pub digest: &'static str,
}

pub struct OptimizedSourceWithDigest {
    pub vert_source: &'static str,
    pub frag_source: &'static str,
    pub digest: &'static str,
}

lazy_static! {
  pub static ref UNOPTIMIZED_SHADERS: HashMap<&'static str, SourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert("base", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/base.glsl"), digest: "d5ae695bab268b7d"});
    shaders.insert("blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/blend.glsl"), digest: "13d73473dd6ff8fa"});
    shaders.insert("brush", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/brush.glsl"), digest: "6c922d89c4f26643"});
    shaders.insert("brush_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/brush_blend.glsl"), digest: "b8282654eaba8bd"});
    shaders.insert("brush_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/brush_image.glsl"), digest: "9ef986bd197aa0a6"});
    shaders.insert("brush_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/brush_linear_gradient.glsl"), digest: "9a2ac73aeb2818d4"});
    shaders.insert("brush_mix_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/brush_mix_blend.glsl"), digest: "80a9451b70a77590"});
    shaders.insert("brush_opacity", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/brush_opacity.glsl"), digest: "b1fff1b8143d04e2"});
    shaders.insert("brush_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/brush_solid.glsl"), digest: "6c2a8a297ae18901"});
    shaders.insert("brush_yuv_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/brush_yuv_image.glsl"), digest: "efed39d5a631ff92"});
    shaders.insert("clip_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/clip_shared.glsl"), digest: "34b82ef3ac08b8a2"});
    shaders.insert("composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/composite.glsl"), digest: "871b56153e6dc970"});
    shaders.insert("cs_blur", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_blur.glsl"), digest: "cf5b5feb52b2ded1"});
    shaders.insert("cs_border_segment", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_border_segment.glsl"), digest: "106a089f234ad0bb"});
    shaders.insert("cs_border_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_border_solid.glsl"), digest: "168d27ef1f35a42f"});
    shaders.insert("cs_clip_box_shadow", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_clip_box_shadow.glsl"), digest: "badcd5e834ef310d"});
    shaders.insert("cs_clip_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_clip_image.glsl"), digest: "504659a9c88b9d62"});
    shaders.insert("cs_clip_rectangle", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_clip_rectangle.glsl"), digest: "ae193f24234ffe7a"});
    shaders.insert("cs_conic_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_conic_gradient.glsl"), digest: "40f2e92e1c17139e"});
    shaders.insert("cs_fast_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_fast_linear_gradient.glsl"), digest: "d9a1e5db0fd6c5d2"});
    shaders.insert("cs_line_decoration", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_line_decoration.glsl"), digest: "2386f3b2be4eda0a"});
    shaders.insert("cs_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_linear_gradient.glsl"), digest: "b345d8647f0c4954"});
    shaders.insert("cs_radial_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_radial_gradient.glsl"), digest: "e5320f3d7417cc31"});
    shaders.insert("cs_scale", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_scale.glsl"), digest: "fc6709e353349d1e"});
    shaders.insert("cs_svg_filter", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/cs_svg_filter.glsl"), digest: "f8ca81dd4669b895"});
    shaders.insert("debug_color", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/debug_color.glsl"), digest: "2f9261e057bd8448"});
    shaders.insert("debug_font", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/debug_font.glsl"), digest: "738d28322b4c39c6"});
    shaders.insert("ellipse", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/ellipse.glsl"), digest: "1883f224293b6515"});
    shaders.insert("gpu_cache", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/gpu_cache.glsl"), digest: "e99b57d9cc26406a"});
    shaders.insert("gpu_cache_update", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/gpu_cache_update.glsl"), digest: "208078c3cbd97aa7"});
    shaders.insert("gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/gradient.glsl"), digest: "8fd15af56b74882f"});
    shaders.insert("gradient_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/gradient_shared.glsl"), digest: "6f3fd5b68c496f08"});
    shaders.insert("prim_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/prim_shared.glsl"), digest: "9ed03c84909f2c3b"});
    shaders.insert("ps_clear", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/ps_clear.glsl"), digest: "81dbbdcf6f3326c5"});
    shaders.insert("ps_copy", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/ps_copy.glsl"), digest: "fee018569bc66328"});
    shaders.insert("ps_split_composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/ps_split_composite.glsl"), digest: "905e32b9a69faaca"});
    shaders.insert("ps_text_run", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/ps_text_run.glsl"), digest: "d0ac5e25780031de"});
    shaders.insert("rect", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/rect.glsl"), digest: "4f129d4925591d33"});
    shaders.insert("render_task", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/render_task.glsl"), digest: "c4574b7a23485833"});
    shaders.insert("shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/shared.glsl"), digest: "4c69e477c1a90ece"});
    shaders.insert("shared_other", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/shared_other.glsl"), digest: "9f6298a27dfe79c6"});
    shaders.insert("transform", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/transform.glsl"), digest: "c783752dc8c02e55"});
    shaders.insert("yuv", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-100.0/gfx/wr/webrender/res/yuv.glsl"), digest: "7c0aaaf364067420"});
    shaders
  };

  pub static ref OPTIMIZED_SHADERS: HashMap<(ShaderVersion, &'static str), OptimizedSourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert((ShaderVersion::Gl, "brush_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_blend_Gl.frag"),
        digest: "a3d83f56db9b3f85",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_blend_ALPHA_PASS_Gl.frag"),
        digest: "8765b8f36a358956",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "1da36e88e1e0fa90",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "42f6e798470f18f4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "2f21b184bfd9ca5c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "7f9ef43c207bbe5b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "c3e8115e4a2910f2",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "54fad46fb7f33e69",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "7bc1a649f3ee501",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "5ca1fde7d5186984",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "3dd69d042ccb8bd5",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "d539661b99d7cbe",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.frag"),
        digest: "ae2dfb61b4138ce4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "bdc0d1e404d16ca0",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "7ace5d509458532a",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "a3ba6cb9d1c86e04",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "7808ca7cb28f20f4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "6a03b8fc4f641c3f",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "aacac617f3054978",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "984bdb2db61c0d1",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.frag"),
        digest: "c777eed5fe8fba4d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_TEXTURE_2D_Gl.frag"),
        digest: "4181c2f25c1d7ea5",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_image_TEXTURE_RECT_Gl.frag"),
        digest: "3c327516b7c6485b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_linear_gradient_Gl.frag"),
        digest: "4e166ec9fbff6ad8",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_linear_gradient_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_linear_gradient_ALPHA_PASS_Gl.frag"),
        digest: "caeb64d26c451f55",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.frag"),
        digest: "3bbf8f5398e70463",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_mix_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_mix_blend_Gl.frag"),
        digest: "2cd4e64a7c00cf87",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_mix_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_mix_blend_ALPHA_PASS_Gl.frag"),
        digest: "f5c012d087875b92",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "935d07ce428909a7",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_Gl.frag"),
        digest: "fbcdc37bd1403eb9",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_ALPHA_PASS_Gl.frag"),
        digest: "824b96debc184b31",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.frag"),
        digest: "6ed6f9bf6cbfd14e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_ANTIALIASING_Gl.frag"),
        digest: "1fafd8de96b76894",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.frag"),
        digest: "ab53cf6fef1237ed",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_opacity_DEBUG_OVERDRAW_Gl.frag"),
        digest: "f8f6d306e927b5e9",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_solid_Gl.frag"),
        digest: "b862ddb8c92fdba2",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_solid_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_solid_ALPHA_PASS_Gl.frag"),
        digest: "beb36f8d8d539846",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_solid_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_solid_DEBUG_OVERDRAW_Gl.frag"),
        digest: "f0580ccbe72a02c8",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.frag"),
        digest: "72688e9d695dd423",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "a554b5e1f30811a0",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.frag"),
        digest: "3a0fbee0c48067fe",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "b721bfc7442a8f84",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.frag"),
        digest: "603d57028069e5ee",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "271ddae4e7e4269a",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_FAST_PATH_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_FAST_PATH_TEXTURE_2D_Gl.frag"),
        digest: "dfccc486768aa9f6",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_FAST_PATH_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_FAST_PATH_TEXTURE_RECT_Gl.frag"),
        digest: "181d9b7fb77535bf",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_TEXTURE_2D_Gl.frag"),
        digest: "9318a023a512c0f7",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_TEXTURE_2D_YUV_Gl.frag"),
        digest: "377a8515e140e2b2",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_TEXTURE_RECT_Gl.frag"),
        digest: "7d92f3363c80c4b9",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/composite_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "e8d6738ec90b1097",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_ALPHA_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_blur_ALPHA_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_blur_ALPHA_TARGET_Gl.frag"),
        digest: "e1ee6b18274ebea4",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_COLOR_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_blur_COLOR_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_blur_COLOR_TARGET_Gl.frag"),
        digest: "44b296e917f5ffe0",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_segment"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_border_segment_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_border_segment_Gl.frag"),
        digest: "8495134f5ed37bf5",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_border_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_border_solid_Gl.frag"),
        digest: "9fd688a8c266d2da",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_box_shadow_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_clip_box_shadow_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_clip_box_shadow_TEXTURE_2D_Gl.frag"),
        digest: "27ebd9a8598b86dd",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_clip_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_clip_image_TEXTURE_2D_Gl.frag"),
        digest: "cc3eb79ed945df7e",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_clip_rectangle_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_clip_rectangle_Gl.frag"),
        digest: "2c8a1dff0fe0a10f",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle_FAST_PATH"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_clip_rectangle_FAST_PATH_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_clip_rectangle_FAST_PATH_Gl.frag"),
        digest: "f2f1ca9e786e5c25",
    });
    shaders.insert((ShaderVersion::Gl, "cs_conic_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_conic_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_conic_gradient_Gl.frag"),
        digest: "b7cda5b4a185979c",
    });
    shaders.insert((ShaderVersion::Gl, "cs_fast_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_fast_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_fast_linear_gradient_Gl.frag"),
        digest: "3d4ec20a2b40f905",
    });
    shaders.insert((ShaderVersion::Gl, "cs_line_decoration"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_line_decoration_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_line_decoration_Gl.frag"),
        digest: "7943c68da0973c69",
    });
    shaders.insert((ShaderVersion::Gl, "cs_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_linear_gradient_Gl.frag"),
        digest: "d472e0930d426d9d",
    });
    shaders.insert((ShaderVersion::Gl, "cs_radial_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_radial_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_radial_gradient_Gl.frag"),
        digest: "da73355e0977ab65",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_scale_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_scale_TEXTURE_2D_Gl.frag"),
        digest: "8b96616ecbcd584b",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_scale_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_scale_TEXTURE_RECT_Gl.frag"),
        digest: "d131714d8283049d",
    });
    shaders.insert((ShaderVersion::Gl, "cs_svg_filter"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_svg_filter_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/cs_svg_filter_Gl.frag"),
        digest: "6595c3bd48da1c2e",
    });
    shaders.insert((ShaderVersion::Gl, "debug_color"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/debug_color_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/debug_color_Gl.frag"),
        digest: "f458fe7ea40bd77e",
    });
    shaders.insert((ShaderVersion::Gl, "debug_font"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/debug_font_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/debug_font_Gl.frag"),
        digest: "503ec56c19b6bd2c",
    });
    shaders.insert((ShaderVersion::Gl, "ps_clear"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_clear_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_clear_Gl.frag"),
        digest: "9ef2acc3bbd621e8",
    });
    shaders.insert((ShaderVersion::Gl, "ps_copy"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_copy_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_copy_Gl.frag"),
        digest: "514726576460ee72",
    });
    shaders.insert((ShaderVersion::Gl, "ps_split_composite"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_split_composite_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_split_composite_Gl.frag"),
        digest: "9567385257869ee1",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "4206a389e17781d0",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "f7f64128b28324e6",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "38b0cb66281e545a",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "f09e4a2ad5873fba",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "4b8cfd14ebbc7b1e",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-100.0/objdir/aarch64-unknown-linux-gnu/release/build/webrender-1925a717ca0864be/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "eed566e8b1b1330d",
    });
    shaders
  };
}
