#ifndef mozilla_dom_BindingNames_h
#define mozilla_dom_BindingNames_h

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioDestinationNode = 335,
  AudioListener = 356,
  AudioNode = 370,
  AudioParam = 380,
  AudioParamMap = 391,
  AudioProcessingEvent = 405,
  AudioScheduledSourceNode = 426,
  AudioTrack = 451,
  AudioTrackList = 462,
  AudioWorklet = 477,
  AudioWorkletGlobalScope = 490,
  AudioWorkletNode = 514,
  AudioWorkletProcessor = 531,
  AuthenticatorAssertionResponse = 553,
  AuthenticatorAttestationResponse = 584,
  AuthenticatorResponse = 617,
  BarProp = 639,
  BaseAudioContext = 647,
  BatteryManager = 664,
  BeforeUnloadEvent = 679,
  BiquadFilterNode = 697,
  Blob = 714,
  BlobEvent = 719,
  BroadcastChannel = 729,
  BrowsingContext = 746,
  BrowsingContextGroup = 762,
  ByteLengthQueuingStrategy = 783,
  CDATASection = 809,
  CSS = 822,
  CSS2Properties = 826,
  CSSAnimation = 841,
  CSSConditionRule = 854,
  CSSCounterStyleRule = 871,
  CSSFontFaceRule = 891,
  CSSFontFeatureValuesRule = 907,
  CSSGroupingRule = 932,
  CSSImportRule = 948,
  CSSKeyframeRule = 962,
  CSSKeyframesRule = 978,
  CSSLayerBlockRule = 995,
  CSSLayerStatementRule = 1013,
  CSSMediaRule = 1035,
  CSSMozDocumentRule = 1048,
  CSSNamespaceRule = 1067,
  CSSPageRule = 1084,
  CSSPseudoElement = 1096,
  CSSRule = 1113,
  CSSRuleList = 1121,
  CSSScrollTimelineRule = 1133,
  CSSStyleDeclaration = 1155,
  CSSStyleRule = 1175,
  CSSStyleSheet = 1188,
  CSSSupportsRule = 1202,
  CSSTransition = 1218,
  Cache = 1232,
  CacheStorage = 1238,
  CallbackDebuggerNotification = 1251,
  CanonicalBrowsingContext = 1280,
  CanvasCaptureMediaStream = 1305,
  CanvasGradient = 1330,
  CanvasPattern = 1345,
  CanvasRenderingContext2D = 1359,
  CaretPosition = 1384,
  CaretStateChangedEvent = 1398,
  ChannelMergerNode = 1421,
  ChannelSplitterNode = 1439,
  ChannelWrapper = 1459,
  CharacterData = 1474,
  CheckerboardReportService = 1488,
  ChildProcessMessageManager = 1514,
  ChildSHistory = 1541,
  ChromeMessageBroadcaster = 1555,
  ChromeMessageSender = 1580,
  ChromeNodeList = 1600,
  ChromeUtils = 1615,
  ChromeWorker = 1627,
  Client = 1640,
  Clients = 1647,
  Clipboard = 1655,
  ClipboardEvent = 1665,
  ClipboardItem = 1680,
  ClonedErrorHolder = 1694,
  CloseEvent = 1712,
  CommandEvent = 1723,
  Comment = 1736,
  CompositionEvent = 1744,
  ConsoleInstance = 1761,
  ConstantSourceNode = 1777,
  ContentFrameMessageManager = 1796,
  ContentProcessMessageManager = 1823,
  ConvolverNode = 1852,
  CountQueuingStrategy = 1866,
  CreateOfferRequest = 1887,
  Credential = 1906,
  CredentialsContainer = 1917,
  Crypto = 1938,
  CryptoKey = 1945,
  CustomElementRegistry = 1955,
  CustomEvent = 1977,
  DOMException = 1989,
  DOMImplementation = 2002,
  DOMLocalization = 2020,
  DOMMatrix = 2036,
  DOMMatrixReadOnly = 2046,
  DOMParser = 2064,
  DOMPoint = 2074,
  DOMPointReadOnly = 2083,
  DOMQuad = 2100,
  DOMRect = 2108,
  DOMRectList = 2116,
  DOMRectReadOnly = 2128,
  DOMRequest = 2144,
  DOMStringList = 2155,
  DOMStringMap = 2169,
  DOMTokenList = 2182,
  DataTransfer = 2195,
  DataTransferItem = 2208,
  DataTransferItemList = 2225,
  DebuggerNotification = 2246,
  DebuggerNotificationObserver = 2267,
  DedicatedWorkerGlobalScope = 2296,
  DelayNode = 2323,
  DeprecationReportBody = 2333,
  DeviceAcceleration = 2355,
  DeviceLightEvent = 2374,
  DeviceMotionEvent = 2391,
  DeviceOrientationEvent = 2409,
  DeviceRotationRate = 2432,
  Directory = 2451,
  Document = 2461,
  DocumentFragment = 2470,
  DocumentL10n = 2487,
  DocumentTimeline = 2500,
  DocumentType = 2517,
  DominatorTree = 2530,
  DragEvent = 2544,
  DynamicsCompressorNode = 2554,
  EXT_blend_minmax = 2577,
  EXT_color_buffer_float = 2594,
  EXT_color_buffer_half_float = 2617,
  EXT_disjoint_timer_query = 2645,
  EXT_float_blend = 2670,
  EXT_frag_depth = 2686,
  EXT_sRGB = 2701,
  EXT_shader_texture_lod = 2710,
  EXT_texture_compression_bptc = 2733,
  EXT_texture_compression_rgtc = 2762,
  EXT_texture_filter_anisotropic = 2791,
  EXT_texture_norm16 = 2822,
  Element = 2841,
  ElementInternals = 2849,
  ErrorEvent = 2866,
  Event = 2877,
  EventCallbackDebuggerNotification = 2883,
  EventCounts = 2917,
  EventSource = 2929,
  EventTarget = 2941,
  Exception = 2953,
  ExtendableEvent = 2963,
  ExtendableMessageEvent = 2979,
  ExtensionAlarms = 3002,
  ExtensionBrowser = 3018,
  ExtensionEventManager = 3035,
  ExtensionMockAPI = 3057,
  ExtensionPort = 3074,
  ExtensionRuntime = 3088,
  ExtensionTest = 3105,
  External = 3119,
  FeaturePolicy = 3128,
  FeaturePolicyViolationReportBody = 3142,
  FetchEvent = 3175,
  FetchObserver = 3186,
  File = 3200,
  FileList = 3205,
  FileReader = 3214,
  FileReaderSync = 3225,
  FileSystem = 3240,
  FileSystemDirectoryEntry = 3251,
  FileSystemDirectoryHandle = 3276,
  FileSystemDirectoryIterator = 3302,
  FileSystemDirectoryReader = 3330,
  FileSystemEntry = 3356,
  FileSystemFileEntry = 3372,
  FileSystemFileHandle = 3392,
  FileSystemHandle = 3413,
  FileSystemSyncAccessHandle = 3430,
  FileSystemWritableFileStream = 3457,
  Flex = 3486,
  FlexItemValues = 3491,
  FlexLineValues = 3506,
  FluentBundle = 3521,
  FluentBundleAsyncIterator = 3534,
  FluentBundleIterator = 3560,
  FluentPattern = 3581,
  FluentResource = 3595,
  FocusEvent = 3610,
  FontFace = 3621,
  FontFaceSet = 3630,
  FontFaceSetIterator = 3642,
  FontFaceSetLoadEvent = 3662,
  FormData = 3683,
  FormData_Iterator = 3692,
  FormDataEvent = 3710,
  FrameCrashedEvent = 3724,
  FrameLoader = 3742,
  GPU = 3754,
  GPUAdapter = 3758,
  GPUBindGroup = 3769,
  GPUBindGroupLayout = 3782,
  GPUBuffer = 3801,
  GPUBufferUsage = 3811,
  GPUCanvasContext = 3826,
  GPUColorWrite = 3843,
  GPUCommandBuffer = 3857,
  GPUCommandEncoder = 3874,
  GPUCompilationInfo = 3892,
  GPUCompilationMessage = 3911,
  GPUComputePassEncoder = 3933,
  GPUComputePipeline = 3955,
  GPUDevice = 3974,
  GPUDeviceLostInfo = 3984,
  GPUMapMode = 4002,
  GPUOutOfMemoryError = 4013,
  GPUPipelineLayout = 4033,
  GPUQuerySet = 4051,
  GPUQueue = 4063,
  GPURenderBundle = 4072,
  GPURenderBundleEncoder = 4088,
  GPURenderPassEncoder = 4111,
  GPURenderPipeline = 4132,
  GPUSampler = 4150,
  GPUShaderModule = 4161,
  GPUShaderStage = 4177,
  GPUSupportedFeatures = 4192,
  GPUSupportedLimits = 4213,
  GPUTexture = 4232,
  GPUTextureUsage = 4243,
  GPUTextureView = 4259,
  GPUUncapturedErrorEvent = 4274,
  GPUValidationError = 4298,
  GainNode = 4317,
  Gamepad = 4326,
  GamepadAxisMoveEvent = 4334,
  GamepadButton = 4355,
  GamepadButtonEvent = 4369,
  GamepadEvent = 4388,
  GamepadHapticActuator = 4401,
  GamepadLightIndicator = 4423,
  GamepadPose = 4445,
  GamepadServiceTest = 4457,
  GamepadTouch = 4476,
  Geolocation = 4489,
  GeolocationCoordinates = 4501,
  GeolocationPosition = 4524,
  GeolocationPositionError = 4544,
  GetUserMediaRequest = 4569,
  GleanCategory = 4589,
  GleanImpl = 4603,
  GleanLabeled = 4613,
  GleanPingsImpl = 4626,
  Grid = 4641,
  GridArea = 4646,
  GridDimension = 4655,
  GridLine = 4669,
  GridLines = 4678,
  GridTrack = 4688,
  GridTracks = 4698,
  HTMLAllCollection = 4709,
  HTMLAnchorElement = 4727,
  HTMLAreaElement = 4745,
  HTMLAudioElement = 4761,
  HTMLBRElement = 4778,
  HTMLBaseElement = 4792,
  HTMLBodyElement = 4808,
  HTMLButtonElement = 4824,
  HTMLCanvasElement = 4842,
  HTMLCollection = 4860,
  HTMLDListElement = 4875,
  HTMLDataElement = 4892,
  HTMLDataListElement = 4908,
  HTMLDetailsElement = 4928,
  HTMLDialogElement = 4947,
  HTMLDirectoryElement = 4965,
  HTMLDivElement = 4986,
  HTMLDocument = 5001,
  HTMLElement = 5014,
  HTMLEmbedElement = 5026,
  HTMLFieldSetElement = 5043,
  HTMLFontElement = 5063,
  HTMLFormControlsCollection = 5079,
  HTMLFormElement = 5106,
  HTMLFrameElement = 5122,
  HTMLFrameSetElement = 5139,
  HTMLHRElement = 5159,
  HTMLHeadElement = 5173,
  HTMLHeadingElement = 5189,
  HTMLHtmlElement = 5208,
  HTMLIFrameElement = 5224,
  HTMLImageElement = 5242,
  HTMLInputElement = 5259,
  HTMLLIElement = 5276,
  HTMLLabelElement = 5290,
  HTMLLegendElement = 5307,
  HTMLLinkElement = 5325,
  HTMLMapElement = 5341,
  HTMLMarqueeElement = 5356,
  HTMLMediaElement = 5375,
  HTMLMenuElement = 5392,
  HTMLMenuItemElement = 5408,
  HTMLMetaElement = 5428,
  HTMLMeterElement = 5444,
  HTMLModElement = 5461,
  HTMLOListElement = 5476,
  HTMLObjectElement = 5493,
  HTMLOptGroupElement = 5511,
  HTMLOptionElement = 5531,
  HTMLOptionsCollection = 5549,
  HTMLOutputElement = 5571,
  HTMLParagraphElement = 5589,
  HTMLParamElement = 5610,
  HTMLPictureElement = 5627,
  HTMLPreElement = 5646,
  HTMLProgressElement = 5661,
  HTMLQuoteElement = 5681,
  HTMLScriptElement = 5698,
  HTMLSelectElement = 5716,
  HTMLSlotElement = 5734,
  HTMLSourceElement = 5750,
  HTMLSpanElement = 5768,
  HTMLStyleElement = 5784,
  HTMLTableCaptionElement = 5801,
  HTMLTableCellElement = 5825,
  HTMLTableColElement = 5846,
  HTMLTableElement = 5866,
  HTMLTableRowElement = 5883,
  HTMLTableSectionElement = 5903,
  HTMLTemplateElement = 5927,
  HTMLTextAreaElement = 5947,
  HTMLTimeElement = 5967,
  HTMLTitleElement = 5983,
  HTMLTrackElement = 6000,
  HTMLUListElement = 6017,
  HTMLUnknownElement = 6034,
  HTMLVideoElement = 6053,
  HashChangeEvent = 6070,
  Headers = 6086,
  Headers_Iterator = 6094,
  HeapSnapshot = 6111,
  History = 6124,
  IDBCursor = 6132,
  IDBCursorWithValue = 6142,
  IDBDatabase = 6161,
  IDBFactory = 6173,
  IDBFileHandle = 6184,
  IDBFileRequest = 6198,
  IDBIndex = 6213,
  IDBKeyRange = 6222,
  IDBLocaleAwareKeyRange = 6234,
  IDBMutableFile = 6257,
  IDBObjectStore = 6272,
  IDBOpenDBRequest = 6287,
  IDBRequest = 6304,
  IDBTransaction = 6315,
  IDBVersionChangeEvent = 6330,
  IIRFilterNode = 6352,
  IOUtils = 6366,
  IdleDeadline = 6374,
  Image = 6387,
  ImageBitmap = 6393,
  ImageBitmapRenderingContext = 6405,
  ImageCapture = 6433,
  ImageCaptureError = 6446,
  ImageCaptureErrorEvent = 6464,
  ImageData = 6487,
  ImageDocument = 6497,
  InputEvent = 6511,
  InspectorFontFace = 6522,
  InspectorUtils = 6540,
  InstallTriggerImpl = 6555,
  IntersectionObserver = 6574,
  IntersectionObserverEntry = 6595,
  IntlUtils = 6621,
  JSProcessActorChild = 6631,
  JSProcessActorParent = 6651,
  JSWindowActorChild = 6672,
  JSWindowActorParent = 6691,
  KeyEvent = 6711,
  KeyboardEvent = 6720,
  KeyframeEffect = 6734,
  L10nFileSource = 6749,
  L10nOverlays = 6764,
  L10nRegistry = 6777,
  LegacyMozTCPSocket = 6790,
  Localization = 6809,
  Location = 6822,
  Lock = 6831,
  LockManager = 6836,
  MIDIAccess = 6848,
  MIDIConnectionEvent = 6859,
  MIDIInput = 6879,
  MIDIInputMap = 6889,
  MIDIMessageEvent = 6902,
  MIDIOutput = 6919,
  MIDIOutputMap = 6930,
  MIDIPort = 6944,
  MOZ_debug = 6953,
  MatchGlob = 6963,
  MatchPattern = 6973,
  MatchPatternSet = 6986,
  MathMLElement = 7002,
  MediaCapabilities = 7016,
  MediaCapabilitiesInfo = 7034,
  MediaControlService = 7056,
  MediaController = 7076,
  MediaDeviceInfo = 7092,
  MediaDevices = 7108,
  MediaElementAudioSourceNode = 7121,
  MediaEncryptedEvent = 7149,
  MediaError = 7169,
  MediaKeyError = 7180,
  MediaKeyMessageEvent = 7194,
  MediaKeySession = 7215,
  MediaKeyStatusMap = 7231,
  MediaKeyStatusMap_Iterator = 7249,
  MediaKeySystemAccess = 7276,
  MediaKeys = 7297,
  MediaList = 7307,
  MediaMetadata = 7317,
  MediaQueryList = 7331,
  MediaQueryListEvent = 7346,
  MediaRecorder = 7366,
  MediaRecorderErrorEvent = 7380,
  MediaSession = 7404,
  MediaSource = 7417,
  MediaStream = 7429,
  MediaStreamAudioDestinationNode = 7441,
  MediaStreamAudioSourceNode = 7473,
  MediaStreamError = 7500,
  MediaStreamEvent = 7517,
  MediaStreamTrack = 7534,
  MediaStreamTrackAudioSourceNode = 7551,
  MediaStreamTrackEvent = 7583,
  MerchantValidationEvent = 7605,
  MessageBroadcaster = 7629,
  MessageChannel = 7648,
  MessageEvent = 7663,
  MessageListenerManager = 7676,
  MessagePort = 7699,
  MessageSender = 7711,
  MimeType = 7725,
  MimeTypeArray = 7734,
  MouseEvent = 7748,
  MouseScrollEvent = 7759,
  MozCanvasPrintState = 7776,
  MozDocumentMatcher = 7796,
  MozDocumentObserver = 7815,
  MozQueryInterface = 7835,
  MozSharedMap = 7853,
  MozSharedMap_Iterator = 7866,
  MozSharedMapChangeEvent = 7888,
  MozStorageAsyncStatementParams = 7912,
  MozStorageStatementParams = 7943,
  MozStorageStatementRow = 7969,
  MozWritableSharedMap = 7992,
  MutationEvent = 8013,
  MutationObserver = 8027,
  MutationRecord = 8044,
  NamedNodeMap = 8059,
  NavigationPreloadManager = 8072,
  Navigator = 8097,
  NetworkInformation = 8107,
  Node = 8126,
  NodeFilter = 8131,
  NodeIterator = 8142,
  NodeList = 8155,
  Notification = 8164,
  NotificationEvent = 8177,
  NotifyPaintEvent = 8195,
  OES_draw_buffers_indexed = 8212,
  OES_element_index_uint = 8237,
  OES_fbo_render_mipmap = 8260,
  OES_standard_derivatives = 8282,
  OES_texture_float = 8307,
  OES_texture_float_linear = 8325,
  OES_texture_half_float = 8350,
  OES_texture_half_float_linear = 8373,
  OES_vertex_array_object = 8403,
  OVR_multiview2 = 8427,
  OfflineAudioCompletionEvent = 8442,
  OfflineAudioContext = 8470,
  OfflineResourceList = 8490,
  OffscreenCanvas = 8510,
  OffscreenCanvasRenderingContext2D = 8526,
  Option = 8560,
  OscillatorNode = 8567,
  PageTransitionEvent = 8582,
  PaintRequest = 8602,
  PaintRequestList = 8615,
  PaintWorkletGlobalScope = 8632,
  PannerNode = 8656,
  ParentProcessMessageManager = 8667,
  Path2D = 8695,
  PathUtils = 8702,
  PaymentAddress = 8712,
  PaymentMethodChangeEvent = 8727,
  PaymentRequest = 8752,
  PaymentRequestUpdateEvent = 8767,
  PaymentResponse = 8793,
  PeerConnectionImpl = 8809,
  PeerConnectionObserver = 8828,
  Performance = 8851,
  PerformanceEntry = 8863,
  PerformanceEntryEvent = 8880,
  PerformanceEventTiming = 8902,
  PerformanceMark = 8925,
  PerformanceMeasure = 8941,
  PerformanceNavigation = 8960,
  PerformanceNavigationTiming = 8982,
  PerformanceObserver = 9010,
  PerformanceObserverEntryList = 9030,
  PerformancePaintTiming = 9059,
  PerformanceResourceTiming = 9082,
  PerformanceServerTiming = 9108,
  PerformanceTiming = 9132,
  PeriodicWave = 9150,
  PermissionStatus = 9163,
  Permissions = 9180,
  PlacesBookmark = 9192,
  PlacesBookmarkAddition = 9207,
  PlacesBookmarkChanged = 9230,
  PlacesBookmarkGuid = 9252,
  PlacesBookmarkMoved = 9271,
  PlacesBookmarkRemoved = 9291,
  PlacesBookmarkTags = 9313,
  PlacesBookmarkTime = 9332,
  PlacesBookmarkTitle = 9351,
  PlacesBookmarkUrl = 9371,
  PlacesEvent = 9389,
  PlacesFavicon = 9401,
  PlacesHistoryCleared = 9415,
  PlacesObservers = 9436,
  PlacesPurgeCaches = 9452,
  PlacesRanking = 9470,
  PlacesVisit = 9484,
  PlacesVisitRemoved = 9496,
  PlacesVisitTitle = 9515,
  PlacesWeakCallbackWrapper = 9532,
  Plugin = 9558,
  PluginArray = 9565,
  PluginCrashedEvent = 9577,
  PointerEvent = 9596,
  PopStateEvent = 9609,
  PopupBlockedEvent = 9623,
  PopupPositionedEvent = 9641,
  PositionStateEvent = 9662,
  PrecompiledScript = 9681,
  PrioEncoder = 9699,
  ProcessMessageManager = 9711,
  ProcessingInstruction = 9733,
  ProgressEvent = 9755,
  PromiseDebugging = 9769,
  PromiseNativeHandler = 9786,
  PromiseRejectionEvent = 9807,
  PublicKeyCredential = 9829,
  PushEvent = 9849,
  PushManager = 9859,
  PushManagerImpl = 9871,
  PushMessageData = 9887,
  PushSubscription = 9903,
  PushSubscriptionOptions = 9920,
  RTCCertificate = 9944,
  RTCDTMFSender = 9959,
  RTCDTMFToneChangeEvent = 9973,
  RTCDataChannel = 9996,
  RTCDataChannelEvent = 10011,
  RTCDtlsTransport = 10031,
  RTCIceCandidate = 10048,
  RTCIdentityProviderRegistrar = 10064,
  RTCPeerConnection = 10093,
  RTCPeerConnectionIceEvent = 10111,
  RTCPeerConnectionStatic = 10137,
  RTCRtpReceiver = 10161,
  RTCRtpSender = 10176,
  RTCRtpTransceiver = 10189,
  RTCSessionDescription = 10207,
  RTCStatsReport = 10229,
  RTCTrackEvent = 10244,
  RadioNodeList = 10258,
  Range = 10272,
  ReadableByteStreamController = 10278,
  ReadableStream = 10307,
  ReadableStreamBYOBReader = 10322,
  ReadableStreamBYOBRequest = 10347,
  ReadableStreamDefaultController = 10373,
  ReadableStreamDefaultReader = 10405,
  Report = 10433,
  ReportBody = 10440,
  ReportingObserver = 10451,
  Request = 10469,
  ResizeObserver = 10477,
  ResizeObserverEntry = 10492,
  ResizeObserverSize = 10512,
  Response = 10531,
  SVGAElement = 10540,
  SVGAngle = 10552,
  SVGAnimateElement = 10561,
  SVGAnimateMotionElement = 10579,
  SVGAnimateTransformElement = 10603,
  SVGAnimatedAngle = 10630,
  SVGAnimatedBoolean = 10647,
  SVGAnimatedEnumeration = 10666,
  SVGAnimatedInteger = 10689,
  SVGAnimatedLength = 10708,
  SVGAnimatedLengthList = 10726,
  SVGAnimatedNumber = 10748,
  SVGAnimatedNumberList = 10766,
  SVGAnimatedPreserveAspectRatio = 10788,
  SVGAnimatedRect = 10819,
  SVGAnimatedString = 10835,
  SVGAnimatedTransformList = 10853,
  SVGAnimationElement = 10878,
  SVGCircleElement = 10898,
  SVGClipPathElement = 10915,
  SVGComponentTransferFunctionElement = 10934,
  SVGDefsElement = 10970,
  SVGDescElement = 10985,
  SVGElement = 11000,
  SVGEllipseElement = 11011,
  SVGFEBlendElement = 11029,
  SVGFEColorMatrixElement = 11047,
  SVGFEComponentTransferElement = 11071,
  SVGFECompositeElement = 11101,
  SVGFEConvolveMatrixElement = 11123,
  SVGFEDiffuseLightingElement = 11150,
  SVGFEDisplacementMapElement = 11178,
  SVGFEDistantLightElement = 11206,
  SVGFEDropShadowElement = 11231,
  SVGFEFloodElement = 11254,
  SVGFEFuncAElement = 11272,
  SVGFEFuncBElement = 11290,
  SVGFEFuncGElement = 11308,
  SVGFEFuncRElement = 11326,
  SVGFEGaussianBlurElement = 11344,
  SVGFEImageElement = 11369,
  SVGFEMergeElement = 11387,
  SVGFEMergeNodeElement = 11405,
  SVGFEMorphologyElement = 11427,
  SVGFEOffsetElement = 11450,
  SVGFEPointLightElement = 11469,
  SVGFESpecularLightingElement = 11492,
  SVGFESpotLightElement = 11521,
  SVGFETileElement = 11543,
  SVGFETurbulenceElement = 11560,
  SVGFilterElement = 11583,
  SVGForeignObjectElement = 11600,
  SVGGElement = 11624,
  SVGGeometryElement = 11636,
  SVGGradientElement = 11655,
  SVGGraphicsElement = 11674,
  SVGImageElement = 11693,
  SVGLength = 11709,
  SVGLengthList = 11719,
  SVGLineElement = 11733,
  SVGLinearGradientElement = 11748,
  SVGMPathElement = 11773,
  SVGMarkerElement = 11789,
  SVGMaskElement = 11806,
  SVGMatrix = 11821,
  SVGMetadataElement = 11831,
  SVGNumber = 11850,
  SVGNumberList = 11860,
  SVGPathElement = 11874,
  SVGPathSeg = 11889,
  SVGPathSegArcAbs = 11900,
  SVGPathSegArcRel = 11917,
  SVGPathSegClosePath = 11934,
  SVGPathSegCurvetoCubicAbs = 11954,
  SVGPathSegCurvetoCubicRel = 11980,
  SVGPathSegCurvetoCubicSmoothAbs = 12006,
  SVGPathSegCurvetoCubicSmoothRel = 12038,
  SVGPathSegCurvetoQuadraticAbs = 12070,
  SVGPathSegCurvetoQuadraticRel = 12100,
  SVGPathSegCurvetoQuadraticSmoothAbs = 12130,
  SVGPathSegCurvetoQuadraticSmoothRel = 12166,
  SVGPathSegLinetoAbs = 12202,
  SVGPathSegLinetoHorizontalAbs = 12222,
  SVGPathSegLinetoHorizontalRel = 12252,
  SVGPathSegLinetoRel = 12282,
  SVGPathSegLinetoVerticalAbs = 12302,
  SVGPathSegLinetoVerticalRel = 12330,
  SVGPathSegList = 12358,
  SVGPathSegMovetoAbs = 12373,
  SVGPathSegMovetoRel = 12393,
  SVGPatternElement = 12413,
  SVGPoint = 12431,
  SVGPointList = 12440,
  SVGPolygonElement = 12453,
  SVGPolylineElement = 12471,
  SVGPreserveAspectRatio = 12490,
  SVGRadialGradientElement = 12513,
  SVGRect = 12538,
  SVGRectElement = 12546,
  SVGSVGElement = 12561,
  SVGScriptElement = 12575,
  SVGSetElement = 12592,
  SVGStopElement = 12606,
  SVGStringList = 12621,
  SVGStyleElement = 12635,
  SVGSwitchElement = 12651,
  SVGSymbolElement = 12668,
  SVGTSpanElement = 12685,
  SVGTextContentElement = 12701,
  SVGTextElement = 12723,
  SVGTextPathElement = 12738,
  SVGTextPositioningElement = 12757,
  SVGTitleElement = 12783,
  SVGTransform = 12799,
  SVGTransformList = 12812,
  SVGUnitTypes = 12829,
  SVGUseElement = 12842,
  SVGViewElement = 12856,
  Sanitizer = 12871,
  Screen = 12881,
  ScreenLuminance = 12888,
  ScreenOrientation = 12904,
  ScriptProcessorNode = 12922,
  ScrollAreaEvent = 12942,
  ScrollViewChangeEvent = 12958,
  SecurityPolicyViolationEvent = 12980,
  Selection = 13009,
  ServiceWorker = 13019,
  ServiceWorkerContainer = 13033,
  ServiceWorkerGlobalScope = 13056,
  ServiceWorkerRegistration = 13081,
  SessionStoreUtils = 13107,
  ShadowRoot = 13125,
  SharedWorker = 13136,
  SharedWorkerGlobalScope = 13149,
  SimpleGestureEvent = 13173,
  SourceBuffer = 13192,
  SourceBufferList = 13205,
  SpeechGrammar = 13222,
  SpeechGrammarList = 13236,
  SpeechRecognition = 13254,
  SpeechRecognitionAlternative = 13272,
  SpeechRecognitionError = 13301,
  SpeechRecognitionEvent = 13324,
  SpeechRecognitionResult = 13347,
  SpeechRecognitionResultList = 13371,
  SpeechSynthesis = 13399,
  SpeechSynthesisErrorEvent = 13415,
  SpeechSynthesisEvent = 13441,
  SpeechSynthesisUtterance = 13462,
  SpeechSynthesisVoice = 13487,
  StaticRange = 13508,
  StereoPannerNode = 13520,
  Storage = 13537,
  StorageEvent = 13545,
  StorageManager = 13558,
  StreamFilter = 13573,
  StreamFilterDataEvent = 13586,
  StructuredCloneHolder = 13608,
  StructuredCloneTester = 13630,
  StyleSheet = 13652,
  StyleSheetApplicableStateChangeEvent = 13663,
  StyleSheetList = 13700,
  SubmitEvent = 13715,
  SubtleCrypto = 13727,
  SyncMessageSender = 13740,
  SyncReadFile = 13758,
  TCPServerSocket = 13771,
  TCPServerSocketEvent = 13787,
  TCPSocket = 13808,
  TCPSocketErrorEvent = 13818,
  TCPSocketEvent = 13838,
  TelemetryStopwatch = 13853,
  TestUtils = 13872,
  TestingDeprecatedInterface = 13882,
  Text = 13909,
  TextClause = 13914,
  TextDecoder = 13925,
  TextEncoder = 13937,
  TextMetrics = 13949,
  TextTrack = 13961,
  TextTrackCue = 13971,
  TextTrackCueList = 13984,
  TextTrackList = 14001,
  TimeEvent = 14015,
  TimeRanges = 14025,
  Touch = 14036,
  TouchEvent = 14042,
  TouchList = 14053,
  TrackEvent = 14063,
  TransceiverImpl = 14074,
  TransformStream = 14090,
  TransformStreamDefaultController = 14106,
  TransitionEvent = 14139,
  TreeColumn = 14155,
  TreeColumns = 14166,
  TreeContentView = 14178,
  TreeWalker = 14194,
  U2F = 14205,
  UDPMessageEvent = 14209,
  UDPSocket = 14225,
  UIEvent = 14235,
  URL = 14243,
  URLSearchParams = 14247,
  URLSearchParams_Iterator = 14263,
  UserInteraction = 14288,
  UserProximityEvent = 14304,
  VRDisplay = 14323,
  VRDisplayCapabilities = 14333,
  VRDisplayEvent = 14355,
  VREyeParameters = 14370,
  VRFieldOfView = 14386,
  VRFrameData = 14400,
  VRMockController = 14412,
  VRMockDisplay = 14429,
  VRPose = 14443,
  VRServiceTest = 14450,
  VRStageParameters = 14464,
  VTTCue = 14482,
  VTTRegion = 14489,
  ValidityState = 14499,
  VideoPlaybackQuality = 14513,
  VideoTrack = 14534,
  VideoTrackList = 14545,
  VisualViewport = 14560,
  WEBGL_color_buffer_float = 14575,
  WEBGL_compressed_texture_astc = 14600,
  WEBGL_compressed_texture_etc = 14630,
  WEBGL_compressed_texture_etc1 = 14659,
  WEBGL_compressed_texture_pvrtc = 14689,
  WEBGL_compressed_texture_s3tc = 14720,
  WEBGL_compressed_texture_s3tc_srgb = 14750,
  WEBGL_debug_renderer_info = 14785,
  WEBGL_debug_shaders = 14811,
  WEBGL_depth_texture = 14831,
  WEBGL_draw_buffers = 14851,
  WEBGL_explicit_present = 14870,
  WEBGL_lose_context = 14893,
  WaveShaperNode = 14912,
  WebExtensionContentScript = 14927,
  WebExtensionPolicy = 14953,
  WebGL2RenderingContext = 14972,
  WebGLActiveInfo = 14995,
  WebGLBuffer = 15011,
  WebGLContextEvent = 15023,
  WebGLFramebuffer = 15041,
  WebGLProgram = 15058,
  WebGLQuery = 15071,
  WebGLRenderbuffer = 15082,
  WebGLRenderingContext = 15100,
  WebGLSampler = 15122,
  WebGLShader = 15135,
  WebGLShaderPrecisionFormat = 15147,
  WebGLSync = 15174,
  WebGLTexture = 15184,
  WebGLTransformFeedback = 15197,
  WebGLUniformLocation = 15220,
  WebGLVertexArrayObject = 15241,
  WebKitCSSMatrix = 15264,
  WebSocket = 15280,
  WebrtcGlobalInformation = 15290,
  WheelEvent = 15314,
  Window = 15325,
  WindowClient = 15332,
  WindowContext = 15345,
  WindowGlobalChild = 15359,
  WindowGlobalParent = 15377,
  WindowRoot = 15396,
  Worker = 15407,
  WorkerDebuggerGlobalScope = 15414,
  WorkerGlobalScope = 15440,
  WorkerLocation = 15458,
  WorkerNavigator = 15473,
  WorkerTestUtils = 15489,
  Worklet = 15505,
  WorkletGlobalScope = 15513,
  WritableStream = 15532,
  WritableStreamDefaultController = 15547,
  WritableStreamDefaultWriter = 15579,
  XMLDocument = 15607,
  XMLHttpRequest = 15619,
  XMLHttpRequestEventTarget = 15634,
  XMLHttpRequestUpload = 15660,
  XMLSerializer = 15681,
  XPathEvaluator = 15695,
  XPathExpression = 15710,
  XPathResult = 15726,
  XRBoundedReferenceSpace = 15738,
  XRFrame = 15762,
  XRInputSource = 15770,
  XRInputSourceArray = 15784,
  XRInputSourceEvent = 15803,
  XRInputSourcesChangeEvent = 15822,
  XRPose = 15848,
  XRReferenceSpace = 15855,
  XRReferenceSpaceEvent = 15872,
  XRRenderState = 15894,
  XRRigidTransform = 15908,
  XRSession = 15925,
  XRSessionEvent = 15935,
  XRSpace = 15950,
  XRSystem = 15958,
  XRView = 15967,
  XRViewerPose = 15974,
  XRViewport = 15987,
  XRWebGLLayer = 15998,
  XSLTProcessor = 16011,
  XULCommandEvent = 16025,
  XULElement = 16041,
  XULFrameElement = 16052,
  XULMenuElement = 16068,
  XULPopupElement = 16083,
  XULTextElement = 16099,
  XULTreeElement = 16114,
  console = 16129,
  mozRTCIceCandidate = 16137,
  mozRTCPeerConnection = 16156,
  mozRTCSessionDescription = 16177,
  webkitSpeechGrammar = 16202,
  webkitSpeechGrammarList = 16222,
  webkitSpeechRecognition = 16246,
  webkitURL = 16270,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // mozilla_dom_BindingNames_h
