// -*- mode: C++ -*-

/* This file is auto-generated by run_glean_parser.py.
   It is only for internal use by types in
   toolkit/components/glean/bindings/private */

#include "mozilla/ClearOnShutdown.h"
#include "mozilla/Maybe.h"
#include "mozilla/Telemetry.h"
#include "mozilla/DataMutex.h"
#include "mozilla/Tuple.h"
#include "nsClassHashtable.h"
#include "nsTHashMap.h"
#include "nsThreadUtils.h"

#ifndef mozilla_glean_ScalarGifftMap_h
#define mozilla_glean_ScalarGifftMap_h

namespace mozilla::glean {

using Telemetry::ScalarID;

typedef nsUint32HashKey SubmetricIdHashKey;
typedef nsTHashMap<SubmetricIdHashKey, Tuple<ScalarID, nsString>>
    SubmetricToLabeledMirrorMapType;
typedef StaticDataMutex<UniquePtr<SubmetricToLabeledMirrorMapType>>
    SubmetricToMirrorMutex;
static inline SubmetricToMirrorMutex::AutoLock GetLabeledMirrorLock() {
  static SubmetricToMirrorMutex sLabeledMirrors("sLabeledMirrors");
  auto lock = sLabeledMirrors.Lock();
  if (!*lock) {
    *lock = MakeUnique<SubmetricToLabeledMirrorMapType>();
    NS_DispatchToMainThread(NS_NewRunnableFunction(__func__, [&] {
      RunOnShutdown([&] {
        auto lock = sLabeledMirrors.Lock();
        *lock = nullptr;  // deletes, see UniquePtr.h
      });
    }));
  }
  return lock;
}

namespace {
class ScalarIDHashKey : public PLDHashEntryHdr {
 public:
  typedef const ScalarID& KeyType;
  typedef const ScalarID* KeyTypePointer;

  explicit ScalarIDHashKey(KeyTypePointer aKey) : mValue(*aKey) {}
  ScalarIDHashKey(ScalarIDHashKey&& aOther)
      : PLDHashEntryHdr(std::move(aOther)), mValue(std::move(aOther.mValue)) {}
  ~ScalarIDHashKey() = default;

  KeyType GetKey() const { return mValue; }
  bool KeyEquals(KeyTypePointer aKey) const { return *aKey == mValue; }

  static KeyTypePointer KeyToPointer(KeyType aKey) { return &aKey; }
  static PLDHashNumber HashKey(KeyTypePointer aKey) {
    return static_cast<std::underlying_type<ScalarID>::type>(*aKey);
  }
  enum { ALLOW_MEMMOVE = true };

 private:
  const ScalarID mValue;
};
}  // namespace
typedef StaticDataMutex<UniquePtr<nsTHashMap<ScalarIDHashKey, TimeStamp>>> TimesToStartsMutex;
static inline TimesToStartsMutex::AutoLock GetTimesToStartsLock() {
  static TimesToStartsMutex sTimespanStarts("sTimespanStarts");
  auto lock = sTimespanStarts.Lock();
  if (!*lock) {
    *lock = MakeUnique<nsTHashMap<ScalarIDHashKey, TimeStamp>>();
    NS_DispatchToMainThread(NS_NewRunnableFunction(__func__, [&] {
      RunOnShutdown([&] {
        auto lock = sTimespanStarts.Lock();
        *lock = nullptr;  // deletes, see UniquePtr.h
      });
    }));
  }
  return lock;
}

static inline bool IsSubmetricId(uint32_t aId) {
  return aId > (1 << 27); // Kept in sync with js.py's ID_BITS, rust.py's min_submetric_id
}

static Maybe<ScalarID> ScalarIdForMetric(uint32_t aId) {
  switch(aId) {
    case 7: { // gifft.validation.main_ping_assembling
      return Some(ScalarID::GIFFT_VALIDATION_MIRROR_FOR_MAIN_PING_ASSEMBLING);
    }
    case 21: { // test_only.mirror_time
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_TIMESPAN);
    }
    case 22: { // test_only.mirror_time_nanos
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_TIMESPAN_NANOS);
    }
    case 23: { // test_only.mirrors_for_labeled_bools
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_LABELED_BOOL);
    }
    case 25: { // test_only.meaning_of_life
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_QUANTITY);
    }
    case 26: { // test_only.ipc.a_counter
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_COUNTER);
    }
    case 27: { // test_only.ipc.a_bool
      return Some(ScalarID::TELEMETRY_TEST_BOOLEAN_KIND);
    }
    case 28: { // test_only.ipc.a_date
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_DATE);
    }
    case 29: { // test_only.ipc.a_string
      return Some(ScalarID::TELEMETRY_TEST_MULTIPLE_STORES_STRING);
    }
    case 33: { // test_only.ipc.a_string_list
      return Some(ScalarID::TELEMETRY_TEST_KEYED_BOOLEAN_KIND);
    }
    case 37: { // test_only.ipc.a_uuid
      return Some(ScalarID::TELEMETRY_TEST_STRING_KIND);
    }
    case 38: { // test_only.ipc.a_labeled_counter
      return Some(ScalarID::TELEMETRY_TEST_ANOTHER_MIRROR_FOR_LABELED_COUNTER);
    }
    case 39: { // test_only.ipc.another_labeled_counter
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_LABELED_COUNTER);
    }
    case 41: { // test_only.ipc.irate
      return Some(ScalarID::TELEMETRY_TEST_MIRROR_FOR_RATE);
    }
    case 61: { // power.cpu_time_bogus_values
      return Some(ScalarID::POWER_CPU_TIME_BOGUS_VALUES);
    }
    case 62: { // power.cpu_time_per_process_type_ms
      return Some(ScalarID::POWER_CPU_TIME_PER_PROCESS_TYPE_MS);
    }
    case 63: { // power.gpu_time_per_process_type_ms
      return Some(ScalarID::POWER_GPU_TIME_PER_PROCESS_TYPE_MS);
    }
    case 64: { // power.gpu_time_bogus_values
      return Some(ScalarID::POWER_GPU_TIME_BOGUS_VALUES);
    }
    case 65: { // power.wakeups_per_process_type
      return Some(ScalarID::POWER_WAKEUPS_PER_PROCESS_TYPE);
    }
    case 66: { // power.total_cpu_time_ms
      return Some(ScalarID::POWER_TOTAL_CPU_TIME_MS);
    }
    case 67: { // power.total_gpu_time_ms
      return Some(ScalarID::POWER_TOTAL_GPU_TIME_MS);
    }
    case 68: { // power.total_thread_wakeups
      return Some(ScalarID::POWER_TOTAL_THREAD_WAKEUPS);
    }
    default: {
      return Nothing();
    }
  }
}

}  // namespace mozilla::glean
#endif  // mozilla_glean_ScalarGifftMaps_h
