#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioDestinationNode" "\0"
  /*   356 */ "AudioListener" "\0"
  /*   370 */ "AudioNode" "\0"
  /*   380 */ "AudioParam" "\0"
  /*   391 */ "AudioParamMap" "\0"
  /*   405 */ "AudioProcessingEvent" "\0"
  /*   426 */ "AudioScheduledSourceNode" "\0"
  /*   451 */ "AudioTrack" "\0"
  /*   462 */ "AudioTrackList" "\0"
  /*   477 */ "AudioWorklet" "\0"
  /*   490 */ "AudioWorkletGlobalScope" "\0"
  /*   514 */ "AudioWorkletNode" "\0"
  /*   531 */ "AudioWorkletProcessor" "\0"
  /*   553 */ "AuthenticatorAssertionResponse" "\0"
  /*   584 */ "AuthenticatorAttestationResponse" "\0"
  /*   617 */ "AuthenticatorResponse" "\0"
  /*   639 */ "BarProp" "\0"
  /*   647 */ "BaseAudioContext" "\0"
  /*   664 */ "BatteryManager" "\0"
  /*   679 */ "BeforeUnloadEvent" "\0"
  /*   697 */ "BiquadFilterNode" "\0"
  /*   714 */ "Blob" "\0"
  /*   719 */ "BlobEvent" "\0"
  /*   729 */ "BroadcastChannel" "\0"
  /*   746 */ "BrowsingContext" "\0"
  /*   762 */ "BrowsingContextGroup" "\0"
  /*   783 */ "ByteLengthQueuingStrategy" "\0"
  /*   809 */ "CDATASection" "\0"
  /*   822 */ "CSS" "\0"
  /*   826 */ "CSS2Properties" "\0"
  /*   841 */ "CSSAnimation" "\0"
  /*   854 */ "CSSConditionRule" "\0"
  /*   871 */ "CSSCounterStyleRule" "\0"
  /*   891 */ "CSSFontFaceRule" "\0"
  /*   907 */ "CSSFontFeatureValuesRule" "\0"
  /*   932 */ "CSSGroupingRule" "\0"
  /*   948 */ "CSSImportRule" "\0"
  /*   962 */ "CSSKeyframeRule" "\0"
  /*   978 */ "CSSKeyframesRule" "\0"
  /*   995 */ "CSSLayerBlockRule" "\0"
  /*  1013 */ "CSSLayerStatementRule" "\0"
  /*  1035 */ "CSSMediaRule" "\0"
  /*  1048 */ "CSSMozDocumentRule" "\0"
  /*  1067 */ "CSSNamespaceRule" "\0"
  /*  1084 */ "CSSPageRule" "\0"
  /*  1096 */ "CSSPseudoElement" "\0"
  /*  1113 */ "CSSRule" "\0"
  /*  1121 */ "CSSRuleList" "\0"
  /*  1133 */ "CSSScrollTimelineRule" "\0"
  /*  1155 */ "CSSStyleDeclaration" "\0"
  /*  1175 */ "CSSStyleRule" "\0"
  /*  1188 */ "CSSStyleSheet" "\0"
  /*  1202 */ "CSSSupportsRule" "\0"
  /*  1218 */ "CSSTransition" "\0"
  /*  1232 */ "Cache" "\0"
  /*  1238 */ "CacheStorage" "\0"
  /*  1251 */ "CallbackDebuggerNotification" "\0"
  /*  1280 */ "CanonicalBrowsingContext" "\0"
  /*  1305 */ "CanvasCaptureMediaStream" "\0"
  /*  1330 */ "CanvasGradient" "\0"
  /*  1345 */ "CanvasPattern" "\0"
  /*  1359 */ "CanvasRenderingContext2D" "\0"
  /*  1384 */ "CaretPosition" "\0"
  /*  1398 */ "CaretStateChangedEvent" "\0"
  /*  1421 */ "ChannelMergerNode" "\0"
  /*  1439 */ "ChannelSplitterNode" "\0"
  /*  1459 */ "ChannelWrapper" "\0"
  /*  1474 */ "CharacterData" "\0"
  /*  1488 */ "CheckerboardReportService" "\0"
  /*  1514 */ "ChildProcessMessageManager" "\0"
  /*  1541 */ "ChildSHistory" "\0"
  /*  1555 */ "ChromeMessageBroadcaster" "\0"
  /*  1580 */ "ChromeMessageSender" "\0"
  /*  1600 */ "ChromeNodeList" "\0"
  /*  1615 */ "ChromeUtils" "\0"
  /*  1627 */ "ChromeWorker" "\0"
  /*  1640 */ "Client" "\0"
  /*  1647 */ "Clients" "\0"
  /*  1655 */ "Clipboard" "\0"
  /*  1665 */ "ClipboardEvent" "\0"
  /*  1680 */ "ClipboardItem" "\0"
  /*  1694 */ "ClonedErrorHolder" "\0"
  /*  1712 */ "CloseEvent" "\0"
  /*  1723 */ "CommandEvent" "\0"
  /*  1736 */ "Comment" "\0"
  /*  1744 */ "CompositionEvent" "\0"
  /*  1761 */ "ConsoleInstance" "\0"
  /*  1777 */ "ConstantSourceNode" "\0"
  /*  1796 */ "ContentFrameMessageManager" "\0"
  /*  1823 */ "ContentProcessMessageManager" "\0"
  /*  1852 */ "ConvolverNode" "\0"
  /*  1866 */ "CountQueuingStrategy" "\0"
  /*  1887 */ "CreateOfferRequest" "\0"
  /*  1906 */ "Credential" "\0"
  /*  1917 */ "CredentialsContainer" "\0"
  /*  1938 */ "Crypto" "\0"
  /*  1945 */ "CryptoKey" "\0"
  /*  1955 */ "CustomElementRegistry" "\0"
  /*  1977 */ "CustomEvent" "\0"
  /*  1989 */ "DOMException" "\0"
  /*  2002 */ "DOMImplementation" "\0"
  /*  2020 */ "DOMLocalization" "\0"
  /*  2036 */ "DOMMatrix" "\0"
  /*  2046 */ "DOMMatrixReadOnly" "\0"
  /*  2064 */ "DOMParser" "\0"
  /*  2074 */ "DOMPoint" "\0"
  /*  2083 */ "DOMPointReadOnly" "\0"
  /*  2100 */ "DOMQuad" "\0"
  /*  2108 */ "DOMRect" "\0"
  /*  2116 */ "DOMRectList" "\0"
  /*  2128 */ "DOMRectReadOnly" "\0"
  /*  2144 */ "DOMRequest" "\0"
  /*  2155 */ "DOMStringList" "\0"
  /*  2169 */ "DOMStringMap" "\0"
  /*  2182 */ "DOMTokenList" "\0"
  /*  2195 */ "DataTransfer" "\0"
  /*  2208 */ "DataTransferItem" "\0"
  /*  2225 */ "DataTransferItemList" "\0"
  /*  2246 */ "DebuggerNotification" "\0"
  /*  2267 */ "DebuggerNotificationObserver" "\0"
  /*  2296 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2323 */ "DelayNode" "\0"
  /*  2333 */ "DeprecationReportBody" "\0"
  /*  2355 */ "DeviceAcceleration" "\0"
  /*  2374 */ "DeviceLightEvent" "\0"
  /*  2391 */ "DeviceMotionEvent" "\0"
  /*  2409 */ "DeviceOrientationEvent" "\0"
  /*  2432 */ "DeviceRotationRate" "\0"
  /*  2451 */ "Directory" "\0"
  /*  2461 */ "Document" "\0"
  /*  2470 */ "DocumentFragment" "\0"
  /*  2487 */ "DocumentL10n" "\0"
  /*  2500 */ "DocumentTimeline" "\0"
  /*  2517 */ "DocumentType" "\0"
  /*  2530 */ "DominatorTree" "\0"
  /*  2544 */ "DragEvent" "\0"
  /*  2554 */ "DynamicsCompressorNode" "\0"
  /*  2577 */ "EXT_blend_minmax" "\0"
  /*  2594 */ "EXT_color_buffer_float" "\0"
  /*  2617 */ "EXT_color_buffer_half_float" "\0"
  /*  2645 */ "EXT_disjoint_timer_query" "\0"
  /*  2670 */ "EXT_float_blend" "\0"
  /*  2686 */ "EXT_frag_depth" "\0"
  /*  2701 */ "EXT_sRGB" "\0"
  /*  2710 */ "EXT_shader_texture_lod" "\0"
  /*  2733 */ "EXT_texture_compression_bptc" "\0"
  /*  2762 */ "EXT_texture_compression_rgtc" "\0"
  /*  2791 */ "EXT_texture_filter_anisotropic" "\0"
  /*  2822 */ "EXT_texture_norm16" "\0"
  /*  2841 */ "Element" "\0"
  /*  2849 */ "ElementInternals" "\0"
  /*  2866 */ "ErrorEvent" "\0"
  /*  2877 */ "Event" "\0"
  /*  2883 */ "EventCallbackDebuggerNotification" "\0"
  /*  2917 */ "EventCounts" "\0"
  /*  2929 */ "EventSource" "\0"
  /*  2941 */ "EventTarget" "\0"
  /*  2953 */ "Exception" "\0"
  /*  2963 */ "ExtendableEvent" "\0"
  /*  2979 */ "ExtendableMessageEvent" "\0"
  /*  3002 */ "ExtensionAlarms" "\0"
  /*  3018 */ "ExtensionBrowser" "\0"
  /*  3035 */ "ExtensionEventManager" "\0"
  /*  3057 */ "ExtensionMockAPI" "\0"
  /*  3074 */ "ExtensionPort" "\0"
  /*  3088 */ "ExtensionRuntime" "\0"
  /*  3105 */ "ExtensionTest" "\0"
  /*  3119 */ "External" "\0"
  /*  3128 */ "FeaturePolicy" "\0"
  /*  3142 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3175 */ "FetchEvent" "\0"
  /*  3186 */ "FetchObserver" "\0"
  /*  3200 */ "File" "\0"
  /*  3205 */ "FileList" "\0"
  /*  3214 */ "FileReader" "\0"
  /*  3225 */ "FileReaderSync" "\0"
  /*  3240 */ "FileSystem" "\0"
  /*  3251 */ "FileSystemDirectoryEntry" "\0"
  /*  3276 */ "FileSystemDirectoryHandle" "\0"
  /*  3302 */ "FileSystemDirectoryIterator" "\0"
  /*  3330 */ "FileSystemDirectoryReader" "\0"
  /*  3356 */ "FileSystemEntry" "\0"
  /*  3372 */ "FileSystemFileEntry" "\0"
  /*  3392 */ "FileSystemFileHandle" "\0"
  /*  3413 */ "FileSystemHandle" "\0"
  /*  3430 */ "FileSystemSyncAccessHandle" "\0"
  /*  3457 */ "FileSystemWritableFileStream" "\0"
  /*  3486 */ "Flex" "\0"
  /*  3491 */ "FlexItemValues" "\0"
  /*  3506 */ "FlexLineValues" "\0"
  /*  3521 */ "FluentBundle" "\0"
  /*  3534 */ "FluentBundleAsyncIterator" "\0"
  /*  3560 */ "FluentBundleIterator" "\0"
  /*  3581 */ "FluentPattern" "\0"
  /*  3595 */ "FluentResource" "\0"
  /*  3610 */ "FocusEvent" "\0"
  /*  3621 */ "FontFace" "\0"
  /*  3630 */ "FontFaceSet" "\0"
  /*  3642 */ "FontFaceSetIterator" "\0"
  /*  3662 */ "FontFaceSetLoadEvent" "\0"
  /*  3683 */ "FormData" "\0"
  /*  3692 */ "FormData Iterator" "\0"
  /*  3710 */ "FormDataEvent" "\0"
  /*  3724 */ "FrameCrashedEvent" "\0"
  /*  3742 */ "FrameLoader" "\0"
  /*  3754 */ "GPU" "\0"
  /*  3758 */ "GPUAdapter" "\0"
  /*  3769 */ "GPUBindGroup" "\0"
  /*  3782 */ "GPUBindGroupLayout" "\0"
  /*  3801 */ "GPUBuffer" "\0"
  /*  3811 */ "GPUBufferUsage" "\0"
  /*  3826 */ "GPUCanvasContext" "\0"
  /*  3843 */ "GPUColorWrite" "\0"
  /*  3857 */ "GPUCommandBuffer" "\0"
  /*  3874 */ "GPUCommandEncoder" "\0"
  /*  3892 */ "GPUCompilationInfo" "\0"
  /*  3911 */ "GPUCompilationMessage" "\0"
  /*  3933 */ "GPUComputePassEncoder" "\0"
  /*  3955 */ "GPUComputePipeline" "\0"
  /*  3974 */ "GPUDevice" "\0"
  /*  3984 */ "GPUDeviceLostInfo" "\0"
  /*  4002 */ "GPUMapMode" "\0"
  /*  4013 */ "GPUOutOfMemoryError" "\0"
  /*  4033 */ "GPUPipelineLayout" "\0"
  /*  4051 */ "GPUQuerySet" "\0"
  /*  4063 */ "GPUQueue" "\0"
  /*  4072 */ "GPURenderBundle" "\0"
  /*  4088 */ "GPURenderBundleEncoder" "\0"
  /*  4111 */ "GPURenderPassEncoder" "\0"
  /*  4132 */ "GPURenderPipeline" "\0"
  /*  4150 */ "GPUSampler" "\0"
  /*  4161 */ "GPUShaderModule" "\0"
  /*  4177 */ "GPUShaderStage" "\0"
  /*  4192 */ "GPUSupportedFeatures" "\0"
  /*  4213 */ "GPUSupportedLimits" "\0"
  /*  4232 */ "GPUTexture" "\0"
  /*  4243 */ "GPUTextureUsage" "\0"
  /*  4259 */ "GPUTextureView" "\0"
  /*  4274 */ "GPUUncapturedErrorEvent" "\0"
  /*  4298 */ "GPUValidationError" "\0"
  /*  4317 */ "GainNode" "\0"
  /*  4326 */ "Gamepad" "\0"
  /*  4334 */ "GamepadAxisMoveEvent" "\0"
  /*  4355 */ "GamepadButton" "\0"
  /*  4369 */ "GamepadButtonEvent" "\0"
  /*  4388 */ "GamepadEvent" "\0"
  /*  4401 */ "GamepadHapticActuator" "\0"
  /*  4423 */ "GamepadLightIndicator" "\0"
  /*  4445 */ "GamepadPose" "\0"
  /*  4457 */ "GamepadServiceTest" "\0"
  /*  4476 */ "GamepadTouch" "\0"
  /*  4489 */ "Geolocation" "\0"
  /*  4501 */ "GeolocationCoordinates" "\0"
  /*  4524 */ "GeolocationPosition" "\0"
  /*  4544 */ "GeolocationPositionError" "\0"
  /*  4569 */ "GetUserMediaRequest" "\0"
  /*  4589 */ "GleanCategory" "\0"
  /*  4603 */ "GleanImpl" "\0"
  /*  4613 */ "GleanLabeled" "\0"
  /*  4626 */ "GleanPingsImpl" "\0"
  /*  4641 */ "Grid" "\0"
  /*  4646 */ "GridArea" "\0"
  /*  4655 */ "GridDimension" "\0"
  /*  4669 */ "GridLine" "\0"
  /*  4678 */ "GridLines" "\0"
  /*  4688 */ "GridTrack" "\0"
  /*  4698 */ "GridTracks" "\0"
  /*  4709 */ "HTMLAllCollection" "\0"
  /*  4727 */ "HTMLAnchorElement" "\0"
  /*  4745 */ "HTMLAreaElement" "\0"
  /*  4761 */ "HTMLAudioElement" "\0"
  /*  4778 */ "HTMLBRElement" "\0"
  /*  4792 */ "HTMLBaseElement" "\0"
  /*  4808 */ "HTMLBodyElement" "\0"
  /*  4824 */ "HTMLButtonElement" "\0"
  /*  4842 */ "HTMLCanvasElement" "\0"
  /*  4860 */ "HTMLCollection" "\0"
  /*  4875 */ "HTMLDListElement" "\0"
  /*  4892 */ "HTMLDataElement" "\0"
  /*  4908 */ "HTMLDataListElement" "\0"
  /*  4928 */ "HTMLDetailsElement" "\0"
  /*  4947 */ "HTMLDialogElement" "\0"
  /*  4965 */ "HTMLDirectoryElement" "\0"
  /*  4986 */ "HTMLDivElement" "\0"
  /*  5001 */ "HTMLDocument" "\0"
  /*  5014 */ "HTMLElement" "\0"
  /*  5026 */ "HTMLEmbedElement" "\0"
  /*  5043 */ "HTMLFieldSetElement" "\0"
  /*  5063 */ "HTMLFontElement" "\0"
  /*  5079 */ "HTMLFormControlsCollection" "\0"
  /*  5106 */ "HTMLFormElement" "\0"
  /*  5122 */ "HTMLFrameElement" "\0"
  /*  5139 */ "HTMLFrameSetElement" "\0"
  /*  5159 */ "HTMLHRElement" "\0"
  /*  5173 */ "HTMLHeadElement" "\0"
  /*  5189 */ "HTMLHeadingElement" "\0"
  /*  5208 */ "HTMLHtmlElement" "\0"
  /*  5224 */ "HTMLIFrameElement" "\0"
  /*  5242 */ "HTMLImageElement" "\0"
  /*  5259 */ "HTMLInputElement" "\0"
  /*  5276 */ "HTMLLIElement" "\0"
  /*  5290 */ "HTMLLabelElement" "\0"
  /*  5307 */ "HTMLLegendElement" "\0"
  /*  5325 */ "HTMLLinkElement" "\0"
  /*  5341 */ "HTMLMapElement" "\0"
  /*  5356 */ "HTMLMarqueeElement" "\0"
  /*  5375 */ "HTMLMediaElement" "\0"
  /*  5392 */ "HTMLMenuElement" "\0"
  /*  5408 */ "HTMLMenuItemElement" "\0"
  /*  5428 */ "HTMLMetaElement" "\0"
  /*  5444 */ "HTMLMeterElement" "\0"
  /*  5461 */ "HTMLModElement" "\0"
  /*  5476 */ "HTMLOListElement" "\0"
  /*  5493 */ "HTMLObjectElement" "\0"
  /*  5511 */ "HTMLOptGroupElement" "\0"
  /*  5531 */ "HTMLOptionElement" "\0"
  /*  5549 */ "HTMLOptionsCollection" "\0"
  /*  5571 */ "HTMLOutputElement" "\0"
  /*  5589 */ "HTMLParagraphElement" "\0"
  /*  5610 */ "HTMLParamElement" "\0"
  /*  5627 */ "HTMLPictureElement" "\0"
  /*  5646 */ "HTMLPreElement" "\0"
  /*  5661 */ "HTMLProgressElement" "\0"
  /*  5681 */ "HTMLQuoteElement" "\0"
  /*  5698 */ "HTMLScriptElement" "\0"
  /*  5716 */ "HTMLSelectElement" "\0"
  /*  5734 */ "HTMLSlotElement" "\0"
  /*  5750 */ "HTMLSourceElement" "\0"
  /*  5768 */ "HTMLSpanElement" "\0"
  /*  5784 */ "HTMLStyleElement" "\0"
  /*  5801 */ "HTMLTableCaptionElement" "\0"
  /*  5825 */ "HTMLTableCellElement" "\0"
  /*  5846 */ "HTMLTableColElement" "\0"
  /*  5866 */ "HTMLTableElement" "\0"
  /*  5883 */ "HTMLTableRowElement" "\0"
  /*  5903 */ "HTMLTableSectionElement" "\0"
  /*  5927 */ "HTMLTemplateElement" "\0"
  /*  5947 */ "HTMLTextAreaElement" "\0"
  /*  5967 */ "HTMLTimeElement" "\0"
  /*  5983 */ "HTMLTitleElement" "\0"
  /*  6000 */ "HTMLTrackElement" "\0"
  /*  6017 */ "HTMLUListElement" "\0"
  /*  6034 */ "HTMLUnknownElement" "\0"
  /*  6053 */ "HTMLVideoElement" "\0"
  /*  6070 */ "HashChangeEvent" "\0"
  /*  6086 */ "Headers" "\0"
  /*  6094 */ "Headers Iterator" "\0"
  /*  6111 */ "HeapSnapshot" "\0"
  /*  6124 */ "History" "\0"
  /*  6132 */ "IDBCursor" "\0"
  /*  6142 */ "IDBCursorWithValue" "\0"
  /*  6161 */ "IDBDatabase" "\0"
  /*  6173 */ "IDBFactory" "\0"
  /*  6184 */ "IDBFileHandle" "\0"
  /*  6198 */ "IDBFileRequest" "\0"
  /*  6213 */ "IDBIndex" "\0"
  /*  6222 */ "IDBKeyRange" "\0"
  /*  6234 */ "IDBLocaleAwareKeyRange" "\0"
  /*  6257 */ "IDBMutableFile" "\0"
  /*  6272 */ "IDBObjectStore" "\0"
  /*  6287 */ "IDBOpenDBRequest" "\0"
  /*  6304 */ "IDBRequest" "\0"
  /*  6315 */ "IDBTransaction" "\0"
  /*  6330 */ "IDBVersionChangeEvent" "\0"
  /*  6352 */ "IIRFilterNode" "\0"
  /*  6366 */ "IOUtils" "\0"
  /*  6374 */ "IdleDeadline" "\0"
  /*  6387 */ "Image" "\0"
  /*  6393 */ "ImageBitmap" "\0"
  /*  6405 */ "ImageBitmapRenderingContext" "\0"
  /*  6433 */ "ImageCapture" "\0"
  /*  6446 */ "ImageCaptureError" "\0"
  /*  6464 */ "ImageCaptureErrorEvent" "\0"
  /*  6487 */ "ImageData" "\0"
  /*  6497 */ "ImageDocument" "\0"
  /*  6511 */ "InputEvent" "\0"
  /*  6522 */ "InspectorFontFace" "\0"
  /*  6540 */ "InspectorUtils" "\0"
  /*  6555 */ "InstallTriggerImpl" "\0"
  /*  6574 */ "IntersectionObserver" "\0"
  /*  6595 */ "IntersectionObserverEntry" "\0"
  /*  6621 */ "IntlUtils" "\0"
  /*  6631 */ "JSProcessActorChild" "\0"
  /*  6651 */ "JSProcessActorParent" "\0"
  /*  6672 */ "JSWindowActorChild" "\0"
  /*  6691 */ "JSWindowActorParent" "\0"
  /*  6711 */ "KeyEvent" "\0"
  /*  6720 */ "KeyboardEvent" "\0"
  /*  6734 */ "KeyframeEffect" "\0"
  /*  6749 */ "L10nFileSource" "\0"
  /*  6764 */ "L10nOverlays" "\0"
  /*  6777 */ "L10nRegistry" "\0"
  /*  6790 */ "LegacyMozTCPSocket" "\0"
  /*  6809 */ "Localization" "\0"
  /*  6822 */ "Location" "\0"
  /*  6831 */ "Lock" "\0"
  /*  6836 */ "LockManager" "\0"
  /*  6848 */ "MIDIAccess" "\0"
  /*  6859 */ "MIDIConnectionEvent" "\0"
  /*  6879 */ "MIDIInput" "\0"
  /*  6889 */ "MIDIInputMap" "\0"
  /*  6902 */ "MIDIMessageEvent" "\0"
  /*  6919 */ "MIDIOutput" "\0"
  /*  6930 */ "MIDIOutputMap" "\0"
  /*  6944 */ "MIDIPort" "\0"
  /*  6953 */ "MOZ_debug" "\0"
  /*  6963 */ "MatchGlob" "\0"
  /*  6973 */ "MatchPattern" "\0"
  /*  6986 */ "MatchPatternSet" "\0"
  /*  7002 */ "MathMLElement" "\0"
  /*  7016 */ "MediaCapabilities" "\0"
  /*  7034 */ "MediaCapabilitiesInfo" "\0"
  /*  7056 */ "MediaControlService" "\0"
  /*  7076 */ "MediaController" "\0"
  /*  7092 */ "MediaDeviceInfo" "\0"
  /*  7108 */ "MediaDevices" "\0"
  /*  7121 */ "MediaElementAudioSourceNode" "\0"
  /*  7149 */ "MediaEncryptedEvent" "\0"
  /*  7169 */ "MediaError" "\0"
  /*  7180 */ "MediaKeyError" "\0"
  /*  7194 */ "MediaKeyMessageEvent" "\0"
  /*  7215 */ "MediaKeySession" "\0"
  /*  7231 */ "MediaKeyStatusMap" "\0"
  /*  7249 */ "MediaKeyStatusMap Iterator" "\0"
  /*  7276 */ "MediaKeySystemAccess" "\0"
  /*  7297 */ "MediaKeys" "\0"
  /*  7307 */ "MediaList" "\0"
  /*  7317 */ "MediaMetadata" "\0"
  /*  7331 */ "MediaQueryList" "\0"
  /*  7346 */ "MediaQueryListEvent" "\0"
  /*  7366 */ "MediaRecorder" "\0"
  /*  7380 */ "MediaRecorderErrorEvent" "\0"
  /*  7404 */ "MediaSession" "\0"
  /*  7417 */ "MediaSource" "\0"
  /*  7429 */ "MediaStream" "\0"
  /*  7441 */ "MediaStreamAudioDestinationNode" "\0"
  /*  7473 */ "MediaStreamAudioSourceNode" "\0"
  /*  7500 */ "MediaStreamError" "\0"
  /*  7517 */ "MediaStreamEvent" "\0"
  /*  7534 */ "MediaStreamTrack" "\0"
  /*  7551 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  7583 */ "MediaStreamTrackEvent" "\0"
  /*  7605 */ "MerchantValidationEvent" "\0"
  /*  7629 */ "MessageBroadcaster" "\0"
  /*  7648 */ "MessageChannel" "\0"
  /*  7663 */ "MessageEvent" "\0"
  /*  7676 */ "MessageListenerManager" "\0"
  /*  7699 */ "MessagePort" "\0"
  /*  7711 */ "MessageSender" "\0"
  /*  7725 */ "MimeType" "\0"
  /*  7734 */ "MimeTypeArray" "\0"
  /*  7748 */ "MouseEvent" "\0"
  /*  7759 */ "MouseScrollEvent" "\0"
  /*  7776 */ "MozCanvasPrintState" "\0"
  /*  7796 */ "MozDocumentMatcher" "\0"
  /*  7815 */ "MozDocumentObserver" "\0"
  /*  7835 */ "MozQueryInterface" "\0"
  /*  7853 */ "MozSharedMap" "\0"
  /*  7866 */ "MozSharedMap Iterator" "\0"
  /*  7888 */ "MozSharedMapChangeEvent" "\0"
  /*  7912 */ "MozStorageAsyncStatementParams" "\0"
  /*  7943 */ "MozStorageStatementParams" "\0"
  /*  7969 */ "MozStorageStatementRow" "\0"
  /*  7992 */ "MozWritableSharedMap" "\0"
  /*  8013 */ "MutationEvent" "\0"
  /*  8027 */ "MutationObserver" "\0"
  /*  8044 */ "MutationRecord" "\0"
  /*  8059 */ "NamedNodeMap" "\0"
  /*  8072 */ "NavigationPreloadManager" "\0"
  /*  8097 */ "Navigator" "\0"
  /*  8107 */ "NetworkInformation" "\0"
  /*  8126 */ "Node" "\0"
  /*  8131 */ "NodeFilter" "\0"
  /*  8142 */ "NodeIterator" "\0"
  /*  8155 */ "NodeList" "\0"
  /*  8164 */ "Notification" "\0"
  /*  8177 */ "NotificationEvent" "\0"
  /*  8195 */ "NotifyPaintEvent" "\0"
  /*  8212 */ "OES_draw_buffers_indexed" "\0"
  /*  8237 */ "OES_element_index_uint" "\0"
  /*  8260 */ "OES_fbo_render_mipmap" "\0"
  /*  8282 */ "OES_standard_derivatives" "\0"
  /*  8307 */ "OES_texture_float" "\0"
  /*  8325 */ "OES_texture_float_linear" "\0"
  /*  8350 */ "OES_texture_half_float" "\0"
  /*  8373 */ "OES_texture_half_float_linear" "\0"
  /*  8403 */ "OES_vertex_array_object" "\0"
  /*  8427 */ "OVR_multiview2" "\0"
  /*  8442 */ "OfflineAudioCompletionEvent" "\0"
  /*  8470 */ "OfflineAudioContext" "\0"
  /*  8490 */ "OfflineResourceList" "\0"
  /*  8510 */ "OffscreenCanvas" "\0"
  /*  8526 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  8560 */ "Option" "\0"
  /*  8567 */ "OscillatorNode" "\0"
  /*  8582 */ "PageTransitionEvent" "\0"
  /*  8602 */ "PaintRequest" "\0"
  /*  8615 */ "PaintRequestList" "\0"
  /*  8632 */ "PaintWorkletGlobalScope" "\0"
  /*  8656 */ "PannerNode" "\0"
  /*  8667 */ "ParentProcessMessageManager" "\0"
  /*  8695 */ "Path2D" "\0"
  /*  8702 */ "PathUtils" "\0"
  /*  8712 */ "PaymentAddress" "\0"
  /*  8727 */ "PaymentMethodChangeEvent" "\0"
  /*  8752 */ "PaymentRequest" "\0"
  /*  8767 */ "PaymentRequestUpdateEvent" "\0"
  /*  8793 */ "PaymentResponse" "\0"
  /*  8809 */ "PeerConnectionImpl" "\0"
  /*  8828 */ "PeerConnectionObserver" "\0"
  /*  8851 */ "Performance" "\0"
  /*  8863 */ "PerformanceEntry" "\0"
  /*  8880 */ "PerformanceEntryEvent" "\0"
  /*  8902 */ "PerformanceEventTiming" "\0"
  /*  8925 */ "PerformanceMark" "\0"
  /*  8941 */ "PerformanceMeasure" "\0"
  /*  8960 */ "PerformanceNavigation" "\0"
  /*  8982 */ "PerformanceNavigationTiming" "\0"
  /*  9010 */ "PerformanceObserver" "\0"
  /*  9030 */ "PerformanceObserverEntryList" "\0"
  /*  9059 */ "PerformancePaintTiming" "\0"
  /*  9082 */ "PerformanceResourceTiming" "\0"
  /*  9108 */ "PerformanceServerTiming" "\0"
  /*  9132 */ "PerformanceTiming" "\0"
  /*  9150 */ "PeriodicWave" "\0"
  /*  9163 */ "PermissionStatus" "\0"
  /*  9180 */ "Permissions" "\0"
  /*  9192 */ "PlacesBookmark" "\0"
  /*  9207 */ "PlacesBookmarkAddition" "\0"
  /*  9230 */ "PlacesBookmarkChanged" "\0"
  /*  9252 */ "PlacesBookmarkGuid" "\0"
  /*  9271 */ "PlacesBookmarkMoved" "\0"
  /*  9291 */ "PlacesBookmarkRemoved" "\0"
  /*  9313 */ "PlacesBookmarkTags" "\0"
  /*  9332 */ "PlacesBookmarkTime" "\0"
  /*  9351 */ "PlacesBookmarkTitle" "\0"
  /*  9371 */ "PlacesBookmarkUrl" "\0"
  /*  9389 */ "PlacesEvent" "\0"
  /*  9401 */ "PlacesFavicon" "\0"
  /*  9415 */ "PlacesHistoryCleared" "\0"
  /*  9436 */ "PlacesObservers" "\0"
  /*  9452 */ "PlacesPurgeCaches" "\0"
  /*  9470 */ "PlacesRanking" "\0"
  /*  9484 */ "PlacesVisit" "\0"
  /*  9496 */ "PlacesVisitRemoved" "\0"
  /*  9515 */ "PlacesVisitTitle" "\0"
  /*  9532 */ "PlacesWeakCallbackWrapper" "\0"
  /*  9558 */ "Plugin" "\0"
  /*  9565 */ "PluginArray" "\0"
  /*  9577 */ "PluginCrashedEvent" "\0"
  /*  9596 */ "PointerEvent" "\0"
  /*  9609 */ "PopStateEvent" "\0"
  /*  9623 */ "PopupBlockedEvent" "\0"
  /*  9641 */ "PopupPositionedEvent" "\0"
  /*  9662 */ "PositionStateEvent" "\0"
  /*  9681 */ "PrecompiledScript" "\0"
  /*  9699 */ "PrioEncoder" "\0"
  /*  9711 */ "ProcessMessageManager" "\0"
  /*  9733 */ "ProcessingInstruction" "\0"
  /*  9755 */ "ProgressEvent" "\0"
  /*  9769 */ "PromiseDebugging" "\0"
  /*  9786 */ "PromiseNativeHandler" "\0"
  /*  9807 */ "PromiseRejectionEvent" "\0"
  /*  9829 */ "PublicKeyCredential" "\0"
  /*  9849 */ "PushEvent" "\0"
  /*  9859 */ "PushManager" "\0"
  /*  9871 */ "PushManagerImpl" "\0"
  /*  9887 */ "PushMessageData" "\0"
  /*  9903 */ "PushSubscription" "\0"
  /*  9920 */ "PushSubscriptionOptions" "\0"
  /*  9944 */ "RTCCertificate" "\0"
  /*  9959 */ "RTCDTMFSender" "\0"
  /*  9973 */ "RTCDTMFToneChangeEvent" "\0"
  /*  9996 */ "RTCDataChannel" "\0"
  /* 10011 */ "RTCDataChannelEvent" "\0"
  /* 10031 */ "RTCDtlsTransport" "\0"
  /* 10048 */ "RTCIceCandidate" "\0"
  /* 10064 */ "RTCIdentityProviderRegistrar" "\0"
  /* 10093 */ "RTCPeerConnection" "\0"
  /* 10111 */ "RTCPeerConnectionIceEvent" "\0"
  /* 10137 */ "RTCPeerConnectionStatic" "\0"
  /* 10161 */ "RTCRtpReceiver" "\0"
  /* 10176 */ "RTCRtpSender" "\0"
  /* 10189 */ "RTCRtpTransceiver" "\0"
  /* 10207 */ "RTCSessionDescription" "\0"
  /* 10229 */ "RTCStatsReport" "\0"
  /* 10244 */ "RTCTrackEvent" "\0"
  /* 10258 */ "RadioNodeList" "\0"
  /* 10272 */ "Range" "\0"
  /* 10278 */ "ReadableByteStreamController" "\0"
  /* 10307 */ "ReadableStream" "\0"
  /* 10322 */ "ReadableStreamBYOBReader" "\0"
  /* 10347 */ "ReadableStreamBYOBRequest" "\0"
  /* 10373 */ "ReadableStreamDefaultController" "\0"
  /* 10405 */ "ReadableStreamDefaultReader" "\0"
  /* 10433 */ "Report" "\0"
  /* 10440 */ "ReportBody" "\0"
  /* 10451 */ "ReportingObserver" "\0"
  /* 10469 */ "Request" "\0"
  /* 10477 */ "ResizeObserver" "\0"
  /* 10492 */ "ResizeObserverEntry" "\0"
  /* 10512 */ "ResizeObserverSize" "\0"
  /* 10531 */ "Response" "\0"
  /* 10540 */ "SVGAElement" "\0"
  /* 10552 */ "SVGAngle" "\0"
  /* 10561 */ "SVGAnimateElement" "\0"
  /* 10579 */ "SVGAnimateMotionElement" "\0"
  /* 10603 */ "SVGAnimateTransformElement" "\0"
  /* 10630 */ "SVGAnimatedAngle" "\0"
  /* 10647 */ "SVGAnimatedBoolean" "\0"
  /* 10666 */ "SVGAnimatedEnumeration" "\0"
  /* 10689 */ "SVGAnimatedInteger" "\0"
  /* 10708 */ "SVGAnimatedLength" "\0"
  /* 10726 */ "SVGAnimatedLengthList" "\0"
  /* 10748 */ "SVGAnimatedNumber" "\0"
  /* 10766 */ "SVGAnimatedNumberList" "\0"
  /* 10788 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 10819 */ "SVGAnimatedRect" "\0"
  /* 10835 */ "SVGAnimatedString" "\0"
  /* 10853 */ "SVGAnimatedTransformList" "\0"
  /* 10878 */ "SVGAnimationElement" "\0"
  /* 10898 */ "SVGCircleElement" "\0"
  /* 10915 */ "SVGClipPathElement" "\0"
  /* 10934 */ "SVGComponentTransferFunctionElement" "\0"
  /* 10970 */ "SVGDefsElement" "\0"
  /* 10985 */ "SVGDescElement" "\0"
  /* 11000 */ "SVGElement" "\0"
  /* 11011 */ "SVGEllipseElement" "\0"
  /* 11029 */ "SVGFEBlendElement" "\0"
  /* 11047 */ "SVGFEColorMatrixElement" "\0"
  /* 11071 */ "SVGFEComponentTransferElement" "\0"
  /* 11101 */ "SVGFECompositeElement" "\0"
  /* 11123 */ "SVGFEConvolveMatrixElement" "\0"
  /* 11150 */ "SVGFEDiffuseLightingElement" "\0"
  /* 11178 */ "SVGFEDisplacementMapElement" "\0"
  /* 11206 */ "SVGFEDistantLightElement" "\0"
  /* 11231 */ "SVGFEDropShadowElement" "\0"
  /* 11254 */ "SVGFEFloodElement" "\0"
  /* 11272 */ "SVGFEFuncAElement" "\0"
  /* 11290 */ "SVGFEFuncBElement" "\0"
  /* 11308 */ "SVGFEFuncGElement" "\0"
  /* 11326 */ "SVGFEFuncRElement" "\0"
  /* 11344 */ "SVGFEGaussianBlurElement" "\0"
  /* 11369 */ "SVGFEImageElement" "\0"
  /* 11387 */ "SVGFEMergeElement" "\0"
  /* 11405 */ "SVGFEMergeNodeElement" "\0"
  /* 11427 */ "SVGFEMorphologyElement" "\0"
  /* 11450 */ "SVGFEOffsetElement" "\0"
  /* 11469 */ "SVGFEPointLightElement" "\0"
  /* 11492 */ "SVGFESpecularLightingElement" "\0"
  /* 11521 */ "SVGFESpotLightElement" "\0"
  /* 11543 */ "SVGFETileElement" "\0"
  /* 11560 */ "SVGFETurbulenceElement" "\0"
  /* 11583 */ "SVGFilterElement" "\0"
  /* 11600 */ "SVGForeignObjectElement" "\0"
  /* 11624 */ "SVGGElement" "\0"
  /* 11636 */ "SVGGeometryElement" "\0"
  /* 11655 */ "SVGGradientElement" "\0"
  /* 11674 */ "SVGGraphicsElement" "\0"
  /* 11693 */ "SVGImageElement" "\0"
  /* 11709 */ "SVGLength" "\0"
  /* 11719 */ "SVGLengthList" "\0"
  /* 11733 */ "SVGLineElement" "\0"
  /* 11748 */ "SVGLinearGradientElement" "\0"
  /* 11773 */ "SVGMPathElement" "\0"
  /* 11789 */ "SVGMarkerElement" "\0"
  /* 11806 */ "SVGMaskElement" "\0"
  /* 11821 */ "SVGMatrix" "\0"
  /* 11831 */ "SVGMetadataElement" "\0"
  /* 11850 */ "SVGNumber" "\0"
  /* 11860 */ "SVGNumberList" "\0"
  /* 11874 */ "SVGPathElement" "\0"
  /* 11889 */ "SVGPathSeg" "\0"
  /* 11900 */ "SVGPathSegArcAbs" "\0"
  /* 11917 */ "SVGPathSegArcRel" "\0"
  /* 11934 */ "SVGPathSegClosePath" "\0"
  /* 11954 */ "SVGPathSegCurvetoCubicAbs" "\0"
  /* 11980 */ "SVGPathSegCurvetoCubicRel" "\0"
  /* 12006 */ "SVGPathSegCurvetoCubicSmoothAbs" "\0"
  /* 12038 */ "SVGPathSegCurvetoCubicSmoothRel" "\0"
  /* 12070 */ "SVGPathSegCurvetoQuadraticAbs" "\0"
  /* 12100 */ "SVGPathSegCurvetoQuadraticRel" "\0"
  /* 12130 */ "SVGPathSegCurvetoQuadraticSmoothAbs" "\0"
  /* 12166 */ "SVGPathSegCurvetoQuadraticSmoothRel" "\0"
  /* 12202 */ "SVGPathSegLinetoAbs" "\0"
  /* 12222 */ "SVGPathSegLinetoHorizontalAbs" "\0"
  /* 12252 */ "SVGPathSegLinetoHorizontalRel" "\0"
  /* 12282 */ "SVGPathSegLinetoRel" "\0"
  /* 12302 */ "SVGPathSegLinetoVerticalAbs" "\0"
  /* 12330 */ "SVGPathSegLinetoVerticalRel" "\0"
  /* 12358 */ "SVGPathSegList" "\0"
  /* 12373 */ "SVGPathSegMovetoAbs" "\0"
  /* 12393 */ "SVGPathSegMovetoRel" "\0"
  /* 12413 */ "SVGPatternElement" "\0"
  /* 12431 */ "SVGPoint" "\0"
  /* 12440 */ "SVGPointList" "\0"
  /* 12453 */ "SVGPolygonElement" "\0"
  /* 12471 */ "SVGPolylineElement" "\0"
  /* 12490 */ "SVGPreserveAspectRatio" "\0"
  /* 12513 */ "SVGRadialGradientElement" "\0"
  /* 12538 */ "SVGRect" "\0"
  /* 12546 */ "SVGRectElement" "\0"
  /* 12561 */ "SVGSVGElement" "\0"
  /* 12575 */ "SVGScriptElement" "\0"
  /* 12592 */ "SVGSetElement" "\0"
  /* 12606 */ "SVGStopElement" "\0"
  /* 12621 */ "SVGStringList" "\0"
  /* 12635 */ "SVGStyleElement" "\0"
  /* 12651 */ "SVGSwitchElement" "\0"
  /* 12668 */ "SVGSymbolElement" "\0"
  /* 12685 */ "SVGTSpanElement" "\0"
  /* 12701 */ "SVGTextContentElement" "\0"
  /* 12723 */ "SVGTextElement" "\0"
  /* 12738 */ "SVGTextPathElement" "\0"
  /* 12757 */ "SVGTextPositioningElement" "\0"
  /* 12783 */ "SVGTitleElement" "\0"
  /* 12799 */ "SVGTransform" "\0"
  /* 12812 */ "SVGTransformList" "\0"
  /* 12829 */ "SVGUnitTypes" "\0"
  /* 12842 */ "SVGUseElement" "\0"
  /* 12856 */ "SVGViewElement" "\0"
  /* 12871 */ "Sanitizer" "\0"
  /* 12881 */ "Screen" "\0"
  /* 12888 */ "ScreenLuminance" "\0"
  /* 12904 */ "ScreenOrientation" "\0"
  /* 12922 */ "ScriptProcessorNode" "\0"
  /* 12942 */ "ScrollAreaEvent" "\0"
  /* 12958 */ "ScrollViewChangeEvent" "\0"
  /* 12980 */ "SecurityPolicyViolationEvent" "\0"
  /* 13009 */ "Selection" "\0"
  /* 13019 */ "ServiceWorker" "\0"
  /* 13033 */ "ServiceWorkerContainer" "\0"
  /* 13056 */ "ServiceWorkerGlobalScope" "\0"
  /* 13081 */ "ServiceWorkerRegistration" "\0"
  /* 13107 */ "SessionStoreUtils" "\0"
  /* 13125 */ "ShadowRoot" "\0"
  /* 13136 */ "SharedWorker" "\0"
  /* 13149 */ "SharedWorkerGlobalScope" "\0"
  /* 13173 */ "SimpleGestureEvent" "\0"
  /* 13192 */ "SourceBuffer" "\0"
  /* 13205 */ "SourceBufferList" "\0"
  /* 13222 */ "SpeechGrammar" "\0"
  /* 13236 */ "SpeechGrammarList" "\0"
  /* 13254 */ "SpeechRecognition" "\0"
  /* 13272 */ "SpeechRecognitionAlternative" "\0"
  /* 13301 */ "SpeechRecognitionError" "\0"
  /* 13324 */ "SpeechRecognitionEvent" "\0"
  /* 13347 */ "SpeechRecognitionResult" "\0"
  /* 13371 */ "SpeechRecognitionResultList" "\0"
  /* 13399 */ "SpeechSynthesis" "\0"
  /* 13415 */ "SpeechSynthesisErrorEvent" "\0"
  /* 13441 */ "SpeechSynthesisEvent" "\0"
  /* 13462 */ "SpeechSynthesisUtterance" "\0"
  /* 13487 */ "SpeechSynthesisVoice" "\0"
  /* 13508 */ "StaticRange" "\0"
  /* 13520 */ "StereoPannerNode" "\0"
  /* 13537 */ "Storage" "\0"
  /* 13545 */ "StorageEvent" "\0"
  /* 13558 */ "StorageManager" "\0"
  /* 13573 */ "StreamFilter" "\0"
  /* 13586 */ "StreamFilterDataEvent" "\0"
  /* 13608 */ "StructuredCloneHolder" "\0"
  /* 13630 */ "StructuredCloneTester" "\0"
  /* 13652 */ "StyleSheet" "\0"
  /* 13663 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 13700 */ "StyleSheetList" "\0"
  /* 13715 */ "SubmitEvent" "\0"
  /* 13727 */ "SubtleCrypto" "\0"
  /* 13740 */ "SyncMessageSender" "\0"
  /* 13758 */ "SyncReadFile" "\0"
  /* 13771 */ "TCPServerSocket" "\0"
  /* 13787 */ "TCPServerSocketEvent" "\0"
  /* 13808 */ "TCPSocket" "\0"
  /* 13818 */ "TCPSocketErrorEvent" "\0"
  /* 13838 */ "TCPSocketEvent" "\0"
  /* 13853 */ "TelemetryStopwatch" "\0"
  /* 13872 */ "TestUtils" "\0"
  /* 13882 */ "TestingDeprecatedInterface" "\0"
  /* 13909 */ "Text" "\0"
  /* 13914 */ "TextClause" "\0"
  /* 13925 */ "TextDecoder" "\0"
  /* 13937 */ "TextEncoder" "\0"
  /* 13949 */ "TextMetrics" "\0"
  /* 13961 */ "TextTrack" "\0"
  /* 13971 */ "TextTrackCue" "\0"
  /* 13984 */ "TextTrackCueList" "\0"
  /* 14001 */ "TextTrackList" "\0"
  /* 14015 */ "TimeEvent" "\0"
  /* 14025 */ "TimeRanges" "\0"
  /* 14036 */ "Touch" "\0"
  /* 14042 */ "TouchEvent" "\0"
  /* 14053 */ "TouchList" "\0"
  /* 14063 */ "TrackEvent" "\0"
  /* 14074 */ "TransceiverImpl" "\0"
  /* 14090 */ "TransformStream" "\0"
  /* 14106 */ "TransformStreamDefaultController" "\0"
  /* 14139 */ "TransitionEvent" "\0"
  /* 14155 */ "TreeColumn" "\0"
  /* 14166 */ "TreeColumns" "\0"
  /* 14178 */ "TreeContentView" "\0"
  /* 14194 */ "TreeWalker" "\0"
  /* 14205 */ "U2F" "\0"
  /* 14209 */ "UDPMessageEvent" "\0"
  /* 14225 */ "UDPSocket" "\0"
  /* 14235 */ "UIEvent" "\0"
  /* 14243 */ "URL" "\0"
  /* 14247 */ "URLSearchParams" "\0"
  /* 14263 */ "URLSearchParams Iterator" "\0"
  /* 14288 */ "UserInteraction" "\0"
  /* 14304 */ "UserProximityEvent" "\0"
  /* 14323 */ "VRDisplay" "\0"
  /* 14333 */ "VRDisplayCapabilities" "\0"
  /* 14355 */ "VRDisplayEvent" "\0"
  /* 14370 */ "VREyeParameters" "\0"
  /* 14386 */ "VRFieldOfView" "\0"
  /* 14400 */ "VRFrameData" "\0"
  /* 14412 */ "VRMockController" "\0"
  /* 14429 */ "VRMockDisplay" "\0"
  /* 14443 */ "VRPose" "\0"
  /* 14450 */ "VRServiceTest" "\0"
  /* 14464 */ "VRStageParameters" "\0"
  /* 14482 */ "VTTCue" "\0"
  /* 14489 */ "VTTRegion" "\0"
  /* 14499 */ "ValidityState" "\0"
  /* 14513 */ "VideoPlaybackQuality" "\0"
  /* 14534 */ "VideoTrack" "\0"
  /* 14545 */ "VideoTrackList" "\0"
  /* 14560 */ "VisualViewport" "\0"
  /* 14575 */ "WEBGL_color_buffer_float" "\0"
  /* 14600 */ "WEBGL_compressed_texture_astc" "\0"
  /* 14630 */ "WEBGL_compressed_texture_etc" "\0"
  /* 14659 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 14689 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 14720 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 14750 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 14785 */ "WEBGL_debug_renderer_info" "\0"
  /* 14811 */ "WEBGL_debug_shaders" "\0"
  /* 14831 */ "WEBGL_depth_texture" "\0"
  /* 14851 */ "WEBGL_draw_buffers" "\0"
  /* 14870 */ "WEBGL_explicit_present" "\0"
  /* 14893 */ "WEBGL_lose_context" "\0"
  /* 14912 */ "WaveShaperNode" "\0"
  /* 14927 */ "WebExtensionContentScript" "\0"
  /* 14953 */ "WebExtensionPolicy" "\0"
  /* 14972 */ "WebGL2RenderingContext" "\0"
  /* 14995 */ "WebGLActiveInfo" "\0"
  /* 15011 */ "WebGLBuffer" "\0"
  /* 15023 */ "WebGLContextEvent" "\0"
  /* 15041 */ "WebGLFramebuffer" "\0"
  /* 15058 */ "WebGLProgram" "\0"
  /* 15071 */ "WebGLQuery" "\0"
  /* 15082 */ "WebGLRenderbuffer" "\0"
  /* 15100 */ "WebGLRenderingContext" "\0"
  /* 15122 */ "WebGLSampler" "\0"
  /* 15135 */ "WebGLShader" "\0"
  /* 15147 */ "WebGLShaderPrecisionFormat" "\0"
  /* 15174 */ "WebGLSync" "\0"
  /* 15184 */ "WebGLTexture" "\0"
  /* 15197 */ "WebGLTransformFeedback" "\0"
  /* 15220 */ "WebGLUniformLocation" "\0"
  /* 15241 */ "WebGLVertexArrayObject" "\0"
  /* 15264 */ "WebKitCSSMatrix" "\0"
  /* 15280 */ "WebSocket" "\0"
  /* 15290 */ "WebrtcGlobalInformation" "\0"
  /* 15314 */ "WheelEvent" "\0"
  /* 15325 */ "Window" "\0"
  /* 15332 */ "WindowClient" "\0"
  /* 15345 */ "WindowContext" "\0"
  /* 15359 */ "WindowGlobalChild" "\0"
  /* 15377 */ "WindowGlobalParent" "\0"
  /* 15396 */ "WindowRoot" "\0"
  /* 15407 */ "Worker" "\0"
  /* 15414 */ "WorkerDebuggerGlobalScope" "\0"
  /* 15440 */ "WorkerGlobalScope" "\0"
  /* 15458 */ "WorkerLocation" "\0"
  /* 15473 */ "WorkerNavigator" "\0"
  /* 15489 */ "WorkerTestUtils" "\0"
  /* 15505 */ "Worklet" "\0"
  /* 15513 */ "WorkletGlobalScope" "\0"
  /* 15532 */ "WritableStream" "\0"
  /* 15547 */ "WritableStreamDefaultController" "\0"
  /* 15579 */ "WritableStreamDefaultWriter" "\0"
  /* 15607 */ "XMLDocument" "\0"
  /* 15619 */ "XMLHttpRequest" "\0"
  /* 15634 */ "XMLHttpRequestEventTarget" "\0"
  /* 15660 */ "XMLHttpRequestUpload" "\0"
  /* 15681 */ "XMLSerializer" "\0"
  /* 15695 */ "XPathEvaluator" "\0"
  /* 15710 */ "XPathExpression" "\0"
  /* 15726 */ "XPathResult" "\0"
  /* 15738 */ "XRBoundedReferenceSpace" "\0"
  /* 15762 */ "XRFrame" "\0"
  /* 15770 */ "XRInputSource" "\0"
  /* 15784 */ "XRInputSourceArray" "\0"
  /* 15803 */ "XRInputSourceEvent" "\0"
  /* 15822 */ "XRInputSourcesChangeEvent" "\0"
  /* 15848 */ "XRPose" "\0"
  /* 15855 */ "XRReferenceSpace" "\0"
  /* 15872 */ "XRReferenceSpaceEvent" "\0"
  /* 15894 */ "XRRenderState" "\0"
  /* 15908 */ "XRRigidTransform" "\0"
  /* 15925 */ "XRSession" "\0"
  /* 15935 */ "XRSessionEvent" "\0"
  /* 15950 */ "XRSpace" "\0"
  /* 15958 */ "XRSystem" "\0"
  /* 15967 */ "XRView" "\0"
  /* 15974 */ "XRViewerPose" "\0"
  /* 15987 */ "XRViewport" "\0"
  /* 15998 */ "XRWebGLLayer" "\0"
  /* 16011 */ "XSLTProcessor" "\0"
  /* 16025 */ "XULCommandEvent" "\0"
  /* 16041 */ "XULElement" "\0"
  /* 16052 */ "XULFrameElement" "\0"
  /* 16068 */ "XULMenuElement" "\0"
  /* 16083 */ "XULPopupElement" "\0"
  /* 16099 */ "XULTextElement" "\0"
  /* 16114 */ "XULTreeElement" "\0"
  /* 16129 */ "console" "\0"
  /* 16137 */ "mozRTCIceCandidate" "\0"
  /* 16156 */ "mozRTCPeerConnection" "\0"
  /* 16177 */ "mozRTCSessionDescription" "\0"
  /* 16202 */ "webkitSpeechGrammar" "\0"
  /* 16222 */ "webkitSpeechGrammarList" "\0"
  /* 16246 */ "webkitSpeechRecognition" "\0"
  /* 16270 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

