//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/embedding/PPrintingParent.h"
#include "mozilla/ProfilerLabels.h"

#include "mozilla/dom/PContentParent.h"
#include "mozilla/dom/PBrowserParent.h"
#include "mozilla/layout/PRemotePrintJobParent.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace embedding {


MOZ_IMPLICIT PPrintingParent::PPrintingParent() :
    mozilla::ipc::IProtocol(PPrintingMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PPrintingParent);
}

PPrintingParent::~PPrintingParent()
{
    MOZ_COUNT_DTOR(PPrintingParent);
}

auto PPrintingParent::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PPrintingParent::Manager() const -> PContentParent*
{
    return static_cast<PContentParent*>(IProtocol::Manager());
}

auto PPrintingParent::ManagedPRemotePrintJobParent(nsTArray<PRemotePrintJobParent*>& aArr) const -> void
{
    mManagedPRemotePrintJobParent.ToArray(aArr);
}

auto PPrintingParent::ManagedPRemotePrintJobParent() const -> const ManagedContainer<PRemotePrintJobParent>&
{
    return mManagedPRemotePrintJobParent;
}

auto PPrintingParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    total += mManagedPRemotePrintJobParent.Count();
    arr__.SetCapacity(total);

    for (auto* key : mManagedPRemotePrintJobParent) {
        arr__.AppendElement(key->GetLifecycleProxy());
    }

}

auto PPrintingParent::OpenPRemotePrintJobEndpoint(PRemotePrintJobParent* aActor) -> ManagedEndpoint<PRemotePrintJobChild>
{
    if (!aActor) {
        NS_WARNING("Cannot bind null PRemotePrintJobParent actor");
        return ManagedEndpoint<PRemotePrintJobChild>();
    }

    aActor->SetManagerAndRegister(this);
    mManagedPRemotePrintJobParent.Insert(aActor);

    // Mark our actor as awaiting the other side to be bound. This will
    // be cleared when a `MANAGED_ENDPOINT_{DROPPED,BOUND}` message is
    // received.
    aActor->mAwaitingManagedEndpointBind = true;
    return ManagedEndpoint<PRemotePrintJobChild>(mozilla::ipc::PrivateIPDLInterface(), aActor);
}

auto PPrintingParent::BindPRemotePrintJobEndpoint(
        ManagedEndpoint<PRemotePrintJobParent> aEndpoint,
        PRemotePrintJobParent* aActor) -> bool
{
    return aEndpoint.Bind(mozilla::ipc::PrivateIPDLInterface(), aActor, this, mManagedPRemotePrintJobParent);
}

auto PPrintingParent::SendPRemotePrintJobConstructor(PRemotePrintJobParent* actor) -> PRemotePrintJobParent*
{
    if (!actor) {
        NS_WARNING("Cannot bind null PRemotePrintJobParent actor");
        return nullptr;
    }

    actor->SetManagerAndRegister(this);
    mManagedPRemotePrintJobParent.Insert(actor);


    // Build our constructor message.
    IPC::Message* msg__ = PPrinting::Msg_PRemotePrintJobConstructor(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    IPC::WriteParam((&(writer__)), actor);
    // Sentinel = 'actor'
    ((&(writer__)))->WriteSentinel(102892058);




    // Notify the other side about the newly created actor. This can
    // fail if our manager has already been destroyed.
    //
    // NOTE: If the send call fails due to toplevel channel teardown,
    // the `IProtocol::ChannelSend` wrapper absorbs the error for us,
    // so we don't tear down actors unexpectedly.

    if (mozilla::ipc::LoggingEnabledFor("PPrintingParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PPrintingParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PPrinting::Msg_PRemotePrintJobConstructor", OTHER);

    bool sendok__ = ChannelSend(msg__);


    // Warn, destroy the actor, and return null if the message failed to
    // send. Otherwise, return the successfully created actor reference.
    if (!sendok__) {
        NS_WARNING("Error sending PRemotePrintJobParent constructor");
        IProtocol* mgr = actor->Manager();
        actor->DestroySubtree(FailedConstructor);
        actor->ClearSubtree();
        mgr->RemoveManagee(PRemotePrintJobMsgStart, actor);

        return nullptr;
    }
    return actor;
}

auto PPrintingParent::Send__delete__(PPrintingParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    IPC::Message* msg__ = PPrinting::Msg___delete__((actor)->Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            actor};

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    IPC::WriteParam((&(writer__)), actor);
    // Sentinel = 'actor'
    ((&(writer__)))->WriteSentinel(102892058);



    if (mozilla::ipc::LoggingEnabledFor("PPrintingParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PPrintingParent",
            actor->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PPrinting::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(msg__);

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PPrintingMsgStart, actor);
    return sendok__;
}

auto PPrintingParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PRemotePrintJobMsgStart:
{
            PRemotePrintJobParent* actor = static_cast<PRemotePrintJobParent*>(aListener);

            const bool removed = mManagedPRemotePrintJobParent.EnsureRemoved(actor);
            MOZ_RELEASE_ASSERT(removed, "actor not managed by this!");

            auto* proxy = actor->GetLifecycleProxy();
            NS_IF_RELEASE(proxy);
            return;
        }    default:
FatalError("unreached");
        return;    }
}

auto PPrintingParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    default:
        FatalError("unreached");
        return;
    }
}

auto PPrintingParent::OnMessageReceived(const Message& msg__) -> PPrintingParent::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PPrintingMsgStart, this);
            return MsgProcessed;
        }
    case PPrinting::Reply_PRemotePrintJobConstructor__ID:
        {
            return MsgProcessed;
        }
    case PPrinting::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PPrintingParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PPrintingParent::Result
{
    return MsgNotKnown;
}

auto PPrintingParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PPrintingParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PPrintingParent::ClearSubtree() -> void
{
    for (auto* key : mManagedPRemotePrintJobParent) {
        key->ClearSubtree();
    }
    for (auto* key : mManagedPRemotePrintJobParent) {
        // Recursively releasing mManagedPRemotePrintJobParent kids.
        auto* proxy = key->GetLifecycleProxy();
        NS_IF_RELEASE(proxy);
    }
    mManagedPRemotePrintJobParent.Clear();

}



} // namespace embedding
} // namespace mozilla
namespace IPC {
auto ParamTraits<mozilla::embedding::PPrintingParent*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<mozilla::embedding::PPrintingParent*>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");

    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aReader->GetActor()->ReadActor(aReader, true, "PPrinting", PPrintingMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::embedding::PPrintingParent*>(actor.value());
    return true;
}

} // namespace IPC
